module interbase;

import std.string;

extern (C) char *getenv(char *varname);
extern (C) int putenv(char *envstring);

extern (Windows) {
extern void *ib_util_malloc(int);

/** Return an environment variable or null if this is not assigned. */
char[] environmentVariable(char[] name)
{
  return toString(getenv(toStringz (name))).dup;
}

/** Assign an environment variable. */
void environmentVariable(char[] name, char[] value)
{
  putenv (toStringz (name ~ "=" ~ value));
}

void setUserAndPassword(char[] name = "ISC_USER", char[] value = "sysdba",
                        char[] name1 = "ISC_PASSWORD", char[] value1 = "masterkey") {
  environmentVariable(name, value);
  environmentVariable(name1, value1);
}

void setDataBase(char[] name = "ISC_DATABASE", char[] value = "\\\\NTserver\\c:\\firebird\\examples") {
  environmentVariable(name, value);
}


alias long   ISC_INT64;
alias ulong  ISC_UINT64;
alias int SLONG;
alias uint ULONG;
alias void* FB_API_HANDLE;

struct SQUAD{
        SLONG high;
        ULONG low;
};

struct GDS_QUAD_t {
        SLONG gds_quad_high;
        ULONG gds_quad_low;
};

alias GDS_QUAD_t GDS_QUAD;
alias GDS_QUAD_t ISC_QUAD;

alias GDS_QUAD.gds_quad_high isc_quad_high;
alias GDS_QUAD.gds_quad_low isc_quad_low;

alias char SCHAR;
alias byte UCHAR;
alias short SSHORT;
alias ushort USHORT;

struct vary
{
        USHORT vary_length;
        char   vary_string[1];
};

struct lstring
{
        ULONG   lstr_length;
        ULONG   lstr_allocated;
        UCHAR*  lstr_address;
};

alias byte BOOLEAN;
alias char TEXT;
alias byte BYTE;
alias int ISC_STATUS;
alias int IPTR;
alias uint U_IPTR;
void (*FPTR_VOID) ();
void (*FPTR_VOID_PTR) (void*);
int (*FPTR_INT) ();
int (*FPTR_INT_VOID_PTR) (void*);
void (*FPTR_PRINT_CALLBACK) (void*, SSHORT, char*);
void (*FPTR_VERSION_CALLBACK)(void*, char*);
void (*FPTR_EVENT_CALLBACK)(void*, USHORT, UCHAR*);
void (*FPTR_ERROR) (ISC_STATUS, ...);
alias ULONG RCRD_OFFSET;
alias USHORT FLD_LENGTH;
alias IPTR LOCK_OWNER_T;
alias int (*lock_ast_t)(void*);
alias IPTR FB_THREAD_ID;

int ISC_STATUS_LENGTH = 20;

alias ISC_STATUS ISC_STATUS_ARRAY[20];

int FB_NELEM(void *x){return (cast(int)(x.sizeof / x[0].sizeof));}
int FB_ALIGN(int n, int b){return ((n + b - 1) & ~(b - 1));}
const int FB_API_VER = 20;
const int ISC_TRUE  = 1;
const int ISC_FALSE = 0;

/*
 * It is difficult to detect 64-bit int from the redistributable header
 * we do not care of 16-bit platforms anymore thus we may use plain "int"
 * which is 32-bit on all platforms we support
 *
 * We'll move to this definition in future API releases.
 *
 */

alias int    ISC_LONG;
alias uint   ISC_ULONG;
alias short  ISC_SHORT;
alias ushort ISC_USHORT;
alias byte   ISC_UCHAR;
alias char   ISC_SCHAR;
/********************************/
/* InterBase Handle Definitions */
/********************************/

alias FB_API_HANDLE isc_att_handle;
alias FB_API_HANDLE isc_blob_handle;
alias FB_API_HANDLE isc_db_handle;
alias FB_API_HANDLE isc_req_handle;
alias FB_API_HANDLE isc_stmt_handle;
alias FB_API_HANDLE isc_svc_handle;
alias FB_API_HANDLE isc_tr_handle;
alias void (* isc_callback) ();
alias ISC_LONG isc_resv_handle;

/*******************************************************************/
/* Time & Date Support                                             */
/*******************************************************************/

alias int   ISC_DATE;
alias uint  ISC_TIME;
struct ISC_TIMESTAMP
{
  ISC_DATE timestamp_date;
  ISC_TIME timestamp_time;
};


/*
 * Included in dsc_pub.h
 * int ISC_TIME_SECONDS_PRECISION          10000L
 * int ISC_TIME_SECONDS_PRECISION_SCALE    (-4)
 */
/*******************************************************************/
/* Blob id structure                                               */
/*******************************************************************/

alias GDS_QUAD GDS__QUAD;

struct ISC_ARRAY_BOUND
{
  short array_bound_lower;
  short array_bound_upper;
};

struct ISC_ARRAY_DESC
{
  ISC_UCHAR array_desc_dtype;
  ISC_SCHAR     array_desc_scale;
  ushort  array_desc_length;
  ISC_SCHAR     array_desc_field_name[32];
  ISC_SCHAR     array_desc_relation_name[32];
  short     array_desc_dimensions;
  short     array_desc_flags;
  ISC_ARRAY_BOUND array_desc_bounds[16];
};

struct ISC_BLOB_DESC
{
  short     blob_desc_subtype;
  short     blob_desc_charset;
  short     blob_desc_segment_size;
  ISC_UCHAR blob_desc_field_name[32];
  ISC_UCHAR blob_desc_relation_name[32];
};

/***************************/
/* Blob control structure  */
/***************************/

struct isc_blob_ctl
{
  ISC_STATUS  (* ctl_source)(); /* Source filter */
  /*struct*/ isc_blob_ctl*  ctl_source_handle;  /* Argument to pass to source filter */
  short         ctl_to_sub_type;    /* Target type */
  short         ctl_from_sub_type;    /* Source type */
  ushort      ctl_buffer_length;    /* Length of buffer */
  ushort      ctl_segment_length;   /* Length of current segment */
  ushort      ctl_bpb_length;     /* Length of blob parameter  block */
  /* Internally, this is UCHAR*, but this public struct probably can't change. */
  ISC_SCHAR*          ctl_bpb;        /* Address of blob parameter block */
  ISC_UCHAR*      ctl_buffer;       /* Address of segment buffer */
  ISC_LONG        ctl_max_segment;    /* Length of longest segment */
  ISC_LONG        ctl_number_segments;  /* Total number of segments */
  ISC_LONG        ctl_total_length;   /* Total length of blob */
  ISC_STATUS*       ctl_status;       /* Address of status vector */
  int         ctl_data[8];      /* Application specific data */
};
alias isc_blob_ctl* ISC_BLOB_CTL;

/***************************/
/* Blob stream definitions */
/***************************/

struct bstream
{
  isc_blob_handle bstr_blob;    /* Blob handle */
  ISC_SCHAR *     bstr_buffer;  /* Address of buffer */
  ISC_SCHAR *     bstr_ptr;   /* Next character */
  short     bstr_length;  /* Length of buffer */
  short     bstr_cnt;   /* Characters in buffer */
  char      bstr_mode;    /* (mode) ? OUTPUT : INPUT */
};
alias bstream BSTREAM;

/* Three ugly macros, one even using octal radix... sigh... */
void getb(BSTREAM *p) {(--p.bstr_cnt >= 0 ? *p.bstr_ptr++ & 0377: BLOB_get(p));}
void putb(ISC_SCHAR x,BSTREAM *p) {((x == '\n' || (!(--p.bstr_cnt))) ? BLOB_put(x,p) : (cast(int)(*p.bstr_ptr++ = cast(uint)x)));}
void putbx(ISC_SCHAR x,BSTREAM *p) {((!(--p.bstr_cnt)) ? BLOB_put(x,p) : (cast(int)(*p.bstr_ptr++ = cast(uint)(x))));}


/********************************************************************/
/* CVC: Public blob interface definition held in val.h.             */
/* For some unknown reason, it was only documented in langRef       */
/* and being the structure passed by the engine to UDFs it never    */
/* made its way into this public definitions file.                  */
/* Being its original name "blob", I renamed it blobcallback here.  */
/* I did the full definition with the proper parameters instead of  */
/* the weak C declaration with any number and type of parameters.   */
/* Since the first parameter -BLB- is unknown outside the engine, */
/* it's more accurate to use void* than int* as the blob pointer    */
/********************************************************************/

/* Blob passing structure */

/* This enum applies to parameter "mode" in blob_lseek */
enum blob_lseek_mode {blb_seek_relative = 1, blb_seek_from_tail = 2};
/* This enum applies to the value returned by blob_get_segment */
enum blob_get_result {blb_got_fragment = -1, blb_got_eof = 0, blb_got_full_segment = 1};

struct blobcallback {
    short (*blob_get_segment)
    (void* hnd, ISC_UCHAR* buffer, ISC_USHORT buf_size, ISC_USHORT* result_len);
    void*   blob_handle;
    ISC_LONG  blob_number_segments;
    ISC_LONG  blob_max_segment;
    ISC_LONG  blob_total_length;
    void (*blob_put_segment)(void* hnd, ISC_UCHAR* buffer, ISC_USHORT buf_size);
    ISC_LONG (*blob_lseek) (void* hnd, ISC_USHORT mode, ISC_LONG offset);
};
alias blobcallback *BLOBCALLBACK;


/********************************************************************/
/* CVC: Public descriptor interface held in dsc2.h.                  */
/* We need it documented to be able to recognize NULL in UDFs.      */
/* Being its original name "dsc", I renamed it paramdsc here.       */
/* Notice that I adjust to the original definition: contrary to     */
/* other cases, the alias is the same struct not the pointer.     */
/* I included the enumeration of dsc_dtype possible values.         */
/* Ultimately, dsc2.h should be part of the public interface.        */
/********************************************************************/

/* This is the famous internal descriptor that UDFs can use, too. */
struct paramdsc {
    ISC_UCHAR dsc_dtype;
    char   dsc_scale;
    ISC_USHORT    dsc_length;
    short   dsc_sub_type;
    ISC_USHORT    dsc_flags;
    ISC_UCHAR *dsc_address;
};
alias paramdsc PARAMDSC;

/* This is a helper struct to work with varchars. */
struct paramvary {
    ISC_USHORT    vary_length;
    ISC_UCHAR   vary_string[1];
};
alias paramvary PARAMVARY;


const int DSC_null = 1;
const int DSC_no_subtype = 2;
const int DSC_nullable = 4;
const int dtype_unknown = 0;
const int dtype_text = 1;
const int dtype_cstring = 2;
const int dtype_varying = 3;
const int dtype_packed = 6;
const int dtype_byte = 7;
const int dtype_short = 8;
const int dtype_long = 9;
const int dtype_quad = 10;
const int dtype_real = 11;
const int dtype_double = 12;
const int dtype_d_float = 13;
const int dtype_sql_date = 14;
const int dtype_sql_time = 15;
const int dtype_timestamp= 16;
const int dtype_blob = 17;
const int dtype_array = 18;
const int dtype_int64 = 19;
const int DTYPE_TYPE_MAX = 20;
const int ISC_TIME_SECONDS_PRECISION = 10000L;
const int ISC_TIME_SECONDS_PRECISION_SCALE = (-4);
 

/***************************/
/* Dynamic SQL definitions */
/***************************/



const int DSQL_close = 1;
const int DSQL_drop = 2;

struct XSQLVAR
{
        SSHORT  sqltype;
        SSHORT  sqlscale;
        SSHORT  sqlsubtype;
        SSHORT  sqllen;
        SCHAR*  sqldata;
        SSHORT* sqlind;
        SSHORT  sqlname_length;
        SCHAR   sqlname[32];
        SSHORT  relname_length;
        SCHAR   relname[32];
        SSHORT  ownname_length;
        SCHAR   ownname[32];
        SSHORT  aliasname_length;
        SCHAR   aliasname[32];
};

const int SQLDA_VERSION1 = 1;

struct XSQLDA
{
        SSHORT  version_;
        SCHAR   sqldaid[8];
        SLONG   sqldabc;
        SSHORT  sqln;
        SSHORT  sqld;
        XSQLVAR sqlvar[1];
};

int XSQLDA_LENGTH(int n){return(XSQLDA.sizeof + (n - 1) * XSQLVAR.sizeof);}
const int SQL_TEXT = 452;
const int SQL_VARYING = 448;
const int SQL_SHORT = 500;
const int SQL_LONG = 496;
const int SQL_FLOAT = 482;
const int SQL_DOUBLE = 480;
const int SQL_D_FLOAT = 530;
const int SQL_TIMESTAMP = 510;
const int SQL_BLOB = 520;
const int SQL_ARRAY = 540;
const int SQL_QUAD = 550;
const int SQL_TYPE_TIME = 560;
const int SQL_TYPE_DATE = 570;
const int SQL_INT64 = 580;
const int SQL_DATE = SQL_TIMESTAMP;
const int SQL_DIALECT_V5 = 1;
const int SQL_DIALECT_V6_TRANSITION = 2;
const int SQL_DIALECT_V6 = 3;
const int SQL_DIALECT_CURRENT = SQL_DIALECT_V6;




/***************************/
/* OSRI database functions */
/***************************/

ISC_STATUS isc_attach_database(ISC_STATUS*, short, ISC_SCHAR*, isc_db_handle*, short, ISC_SCHAR*);
ISC_STATUS isc_array_gen_sdl(ISC_STATUS*, ISC_ARRAY_DESC*, ISC_SHORT*, ISC_UCHAR*, ISC_SHORT*);
ISC_STATUS isc_array_get_slice(ISC_STATUS*, isc_db_handle*, isc_tr_handle*, ISC_QUAD*, ISC_ARRAY_DESC*, void*, ISC_LONG*);
ISC_STATUS isc_array_lookup_bounds(ISC_STATUS*, isc_db_handle*, isc_tr_handle*, ISC_SCHAR*, ISC_SCHAR*, ISC_ARRAY_DESC*);
ISC_STATUS isc_array_lookup_desc(ISC_STATUS*, isc_db_handle*, isc_tr_handle*, ISC_SCHAR*, ISC_SCHAR*, ISC_ARRAY_DESC*);
ISC_STATUS isc_array_set_desc(ISC_STATUS*, ISC_SCHAR*, ISC_SCHAR*, short*, short*, short*, ISC_ARRAY_DESC*);
ISC_STATUS isc_array_put_slice(ISC_STATUS*, isc_db_handle*, isc_tr_handle*, ISC_QUAD*, ISC_ARRAY_DESC*, void*, ISC_LONG *);
void isc_blob_default_desc(ISC_BLOB_DESC*, ISC_UCHAR*, ISC_UCHAR*);
ISC_STATUS isc_blob_gen_bpb(ISC_STATUS*, ISC_BLOB_DESC*, ISC_BLOB_DESC*, ushort, ISC_UCHAR*, ushort*);
ISC_STATUS isc_blob_info(ISC_STATUS*, isc_blob_handle*, short, ISC_SCHAR*, short, ISC_SCHAR*);
ISC_STATUS isc_blob_lookup_desc(ISC_STATUS*, isc_db_handle*, isc_tr_handle*, ISC_UCHAR*, ISC_UCHAR*, ISC_BLOB_DESC*, ISC_UCHAR*);
ISC_STATUS isc_blob_set_desc(ISC_STATUS*, ISC_UCHAR*, ISC_UCHAR*, short, short, short, ISC_BLOB_DESC*);
ISC_STATUS isc_cancel_blob(ISC_STATUS *, isc_blob_handle *);
ISC_STATUS isc_cancel_events(ISC_STATUS *, isc_db_handle *, ISC_LONG *);
ISC_STATUS isc_close_blob(ISC_STATUS *, isc_blob_handle *);
ISC_STATUS isc_commit_retaining(ISC_STATUS *, isc_tr_handle *);
ISC_STATUS isc_commit_transaction(ISC_STATUS *, isc_tr_handle *);
ISC_STATUS isc_create_blob(ISC_STATUS*, isc_db_handle*, isc_tr_handle*, isc_blob_handle*, ISC_QUAD*);
ISC_STATUS isc_create_blob2(ISC_STATUS*, isc_db_handle*, isc_tr_handle*, isc_blob_handle*, ISC_QUAD*, short, ISC_SCHAR*);
ISC_STATUS isc_create_database(ISC_STATUS*, short, ISC_SCHAR*, isc_db_handle*, short, ISC_SCHAR*, short);
ISC_STATUS isc_database_info(ISC_STATUS*, isc_db_handle*, short, ISC_SCHAR*, short, ISC_SCHAR*);
void isc_decode_date(ISC_QUAD*, void*);
void isc_decode_sql_date(ISC_DATE*, void*);
void isc_decode_sql_time(ISC_TIME*, void*);
void isc_decode_timestamp(ISC_TIMESTAMP*, void*);
ISC_STATUS isc_detach_database(ISC_STATUS *, isc_db_handle *);
ISC_STATUS isc_drop_database(ISC_STATUS *, isc_db_handle *);
ISC_STATUS isc_dsql_allocate_statement(ISC_STATUS *, isc_db_handle *, isc_stmt_handle *);
ISC_STATUS isc_dsql_alloc_statement2(ISC_STATUS *, isc_db_handle *, isc_stmt_handle *);
ISC_STATUS isc_dsql_describe(ISC_STATUS *, isc_stmt_handle *, ushort, XSQLDA *);
ISC_STATUS isc_dsql_describe_bind(ISC_STATUS *, isc_stmt_handle *, ushort, XSQLDA *);
ISC_STATUS isc_dsql_exec_immed2(ISC_STATUS*, isc_db_handle*, isc_tr_handle*, ushort, ISC_SCHAR*, ushort, XSQLDA*, XSQLDA*);
ISC_STATUS isc_dsql_execute(ISC_STATUS*, isc_tr_handle*, isc_stmt_handle*, ushort, XSQLDA*);
ISC_STATUS isc_dsql_execute2(ISC_STATUS*, isc_tr_handle*, isc_stmt_handle*, ushort, XSQLDA*, XSQLDA*);
ISC_STATUS isc_dsql_execute_immediate(ISC_STATUS*, isc_db_handle*, isc_tr_handle*, ushort, ISC_SCHAR*, ushort, XSQLDA*);
ISC_STATUS isc_dsql_fetch(ISC_STATUS *, isc_stmt_handle *, ushort, XSQLDA *);
ISC_STATUS isc_dsql_finish(isc_db_handle *);
ISC_STATUS isc_dsql_free_statement(ISC_STATUS *, isc_stmt_handle *, ushort);
ISC_STATUS isc_dsql_insert(ISC_STATUS*, isc_stmt_handle*, ushort, XSQLDA*);
ISC_STATUS isc_dsql_prepare(ISC_STATUS*, isc_tr_handle*, isc_stmt_handle*, ushort, ISC_SCHAR*, ushort, XSQLDA*);
ISC_STATUS isc_dsql_set_cursor_name(ISC_STATUS*, isc_stmt_handle*, ISC_SCHAR*, ushort);
ISC_STATUS isc_dsql_sql_info(ISC_STATUS*, isc_stmt_handle*, short, ISC_SCHAR*, short, ISC_SCHAR*);
void isc_encode_date(void*, ISC_QUAD*);
void isc_encode_sql_date(void*, ISC_DATE*);
void isc_encode_sql_time(void*, ISC_TIME*);
void isc_encode_timestamp(void*, ISC_TIMESTAMP*);
extern (C) ISC_LONG isc_event_block(ISC_SCHAR**, ISC_SCHAR**, ushort, ...);
void isc_event_counts(ISC_ULONG*, short, ISC_SCHAR*, ISC_UCHAR *);
/* 17 May 2001 - isc_expand_dpb is DEPRECATED */
extern (C) void isc_expand_dpb(ISC_SCHAR**, short*, ...);
int isc_modify_dpb(ISC_SCHAR**, short*, ushort, ISC_SCHAR*, short);
ISC_LONG isc_free(ISC_SCHAR *);
ISC_STATUS isc_get_segment(ISC_STATUS *, isc_blob_handle *, ushort *, ushort, ISC_SCHAR *);
ISC_STATUS isc_get_slice(ISC_STATUS*, isc_db_handle*, isc_tr_handle*, ISC_QUAD*, short, ISC_SCHAR*, short, ISC_LONG*, ISC_LONG, void*, ISC_LONG*);

/* CVC: This non-signature is needed for compatibility, see gds.cpp. */
ISC_LONG  isc_interprete(ISC_SCHAR*, ISC_STATUS**);

/* This params version used in the engine and other places. */
ISC_LONG fb_interpret(ISC_SCHAR*, int, ISC_STATUS**);
ISC_STATUS isc_open_blob(ISC_STATUS*, isc_db_handle*, isc_tr_handle*, isc_blob_handle*, ISC_QUAD*);
ISC_STATUS isc_open_blob2(ISC_STATUS*, isc_db_handle*, isc_tr_handle*, isc_blob_handle*, ISC_QUAD*, ISC_USHORT, ISC_UCHAR*);
ISC_STATUS isc_prepare_transaction2(ISC_STATUS*, isc_tr_handle*, ISC_USHORT, ISC_UCHAR*);
void isc_print_sqlerror(ISC_SHORT, ISC_STATUS*);
ISC_STATUS isc_print_status(ISC_STATUS*);
ISC_STATUS isc_put_segment(ISC_STATUS*, isc_blob_handle*, ushort, ISC_SCHAR*);
ISC_STATUS isc_put_slice(ISC_STATUS*, isc_db_handle*, isc_tr_handle*, ISC_QUAD*, short, ISC_SCHAR*, short, ISC_LONG*, ISC_LONG, void*);
//ISC_STATUS isc_que_events(ISC_STATUS*, isc_db_handle*, ISC_LONG*, short, ISC_SCHAR*, FPTR_EVENT_CALLBACK *, void *);
ISC_STATUS isc_rollback_retaining(ISC_STATUS *, isc_tr_handle *);
ISC_STATUS isc_rollback_transaction(ISC_STATUS *, isc_tr_handle *);
ISC_STATUS isc_start_multiple(ISC_STATUS *, isc_tr_handle *, short, void *);
extern (C) ISC_STATUS isc_start_transaction(ISC_STATUS *, isc_tr_handle *, short, ...);
ISC_LONG isc_sqlcode(ISC_STATUS*);
void isc_sql_interprete(short, ISC_SCHAR *, short);
ISC_STATUS isc_transaction_info(ISC_STATUS*, isc_tr_handle*, short, ISC_SCHAR*, short, ISC_SCHAR*);
ISC_STATUS isc_transact_request(ISC_STATUS*, isc_db_handle*, isc_tr_handle*, ushort, ISC_SCHAR*, ushort, ISC_SCHAR*, ushort, ISC_SCHAR*);
ISC_LONG isc_vax_integer(ISC_SCHAR*, short);
ISC_INT64 isc_portable_integer(ISC_UCHAR*, short);

/*************************************/
/* Security Functions and structures */
/*************************************/

const int sec_uid_spec = 0x01;
const int sec_gid_spec = 0x02;
const int sec_server_spec = 0x04;
const int sec_password_spec = 0x08;
const int sec_group_name_spec = 0x10;
const int sec_first_name_spec = 0x20;
const int sec_middle_name_spec = 0x40;
const int sec_last_name_spec = 0x80;
const int sec_dba_user_name_spec = 0x100;
const int sec_dba_password_spec = 0x200;
const int sec_protocol_tcpip = 1;
const int sec_protocol_netbeui = 2;
const int sec_protocol_spx = 3; /* -- Deprecated Protocol. Declaration retained for compatibility   */
const int sec_protocol_local = 4;

struct USER_SEC_DATA {
  short sec_flags;      /* which fields are specified */
  int uid;          /* the user's id */
  int gid;          /* the user's group id */
  int protocol;       /* protocol to use for connection */
  ISC_SCHAR *server;        /* server to administer */
  ISC_SCHAR *user_name;     /* the user's name */
  ISC_SCHAR *password;        /* the user's password */
  ISC_SCHAR *group_name;      /* the group name */
  ISC_SCHAR *first_name;      /* the user's first name */
  ISC_SCHAR *middle_name;     /* the user's middle name */
  ISC_SCHAR *last_name;     /* the user's last name */
  ISC_SCHAR *dba_user_name;   /* the dba user name */
  ISC_SCHAR *dba_password;      /* the dba password */
};

ISC_STATUS isc_add_user(ISC_STATUS*, USER_SEC_DATA*);
ISC_STATUS isc_delete_user(ISC_STATUS*, USER_SEC_DATA*);
ISC_STATUS isc_modify_user(ISC_STATUS*, USER_SEC_DATA*);

/**********************************/
/*  Other OSRI functions          */
/**********************************/

ISC_STATUS isc_compile_request(ISC_STATUS*, isc_db_handle*, isc_req_handle*, short, ISC_SCHAR*);
ISC_STATUS isc_compile_request2(ISC_STATUS*, isc_db_handle*, isc_req_handle*, short, ISC_SCHAR*);
ISC_STATUS isc_ddl(ISC_STATUS*, isc_db_handle*, isc_tr_handle*, short, ISC_SCHAR*);
ISC_STATUS isc_prepare_transaction(ISC_STATUS*, isc_tr_handle*);
ISC_STATUS isc_receive(ISC_STATUS*, isc_req_handle*, short, short, void*, short);
ISC_STATUS isc_reconnect_transaction(ISC_STATUS*, isc_db_handle*, isc_tr_handle*, short, ISC_SCHAR*);
ISC_STATUS isc_release_request(ISC_STATUS*, isc_req_handle*);
ISC_STATUS isc_request_info(ISC_STATUS*, isc_req_handle*, short, short, ISC_SCHAR*, short, ISC_SCHAR*);
ISC_STATUS isc_seek_blob(ISC_STATUS*, isc_blob_handle*, short, ISC_LONG, ISC_LONG*);
ISC_STATUS isc_send(ISC_STATUS*, isc_req_handle*, short, short, void*, short);
ISC_STATUS isc_start_and_send(ISC_STATUS*, isc_req_handle*, isc_tr_handle*, short, short, void*, short);
ISC_STATUS isc_start_request(ISC_STATUS *, isc_req_handle *, isc_tr_handle *, short);
ISC_STATUS isc_unwind_request(ISC_STATUS *, isc_tr_handle *, short);
ISC_STATUS isc_wait_for_event(ISC_STATUS*, isc_db_handle*, short, ISC_SCHAR*, ISC_SCHAR*);


/*****************************/
/* Other Sql functions       */
/*****************************/

ISC_STATUS isc_close(ISC_STATUS*, ISC_SCHAR*);
ISC_STATUS isc_declare(ISC_STATUS*, ISC_SCHAR*, ISC_SCHAR*);
ISC_STATUS isc_describe(ISC_STATUS*, ISC_SCHAR*, XSQLDA *);
ISC_STATUS isc_describe_bind(ISC_STATUS*, ISC_SCHAR*, XSQLDA*);
ISC_STATUS isc_execute(ISC_STATUS*, isc_tr_handle*, ISC_SCHAR*, XSQLDA*);
ISC_STATUS isc_execute_immediate(ISC_STATUS*, isc_db_handle*, isc_tr_handle*, short*, ISC_SCHAR*);
ISC_STATUS isc_fetch(ISC_STATUS*, ISC_SCHAR*, XSQLDA*);
ISC_STATUS isc_open(ISC_STATUS*, isc_tr_handle*, ISC_SCHAR*, XSQLDA*);
ISC_STATUS isc_prepare(ISC_STATUS*, isc_db_handle*, isc_tr_handle*, ISC_SCHAR*, short*, ISC_SCHAR*, XSQLDA*);


/*************************************/
/* Other Dynamic sql functions       */
/*************************************/

ISC_STATUS isc_dsql_execute_m(ISC_STATUS*, isc_tr_handle*, isc_stmt_handle*, ushort, ISC_SCHAR*, ushort, ushort, ISC_SCHAR*);
ISC_STATUS isc_dsql_execute2_m(ISC_STATUS*, isc_tr_handle*, isc_stmt_handle*, ushort, ISC_SCHAR*, ushort, ushort, ISC_SCHAR*, ushort, ISC_SCHAR*, ushort, ushort, ISC_SCHAR*);
ISC_STATUS isc_dsql_execute_immediate_m(ISC_STATUS*, isc_db_handle*, isc_tr_handle*, ushort, ISC_SCHAR*, ushort, ushort, ISC_SCHAR*, ushort, ushort, ISC_SCHAR*);
ISC_STATUS isc_dsql_exec_immed3_m(ISC_STATUS*, isc_db_handle*, isc_tr_handle*, ushort, ISC_SCHAR*, ushort, ushort, ISC_SCHAR*, ushort, ushort, ISC_SCHAR*, ushort, ISC_SCHAR*, ushort, ushort, ISC_SCHAR*);
ISC_STATUS isc_dsql_fetch_m(ISC_STATUS*, isc_stmt_handle*, ushort, ISC_SCHAR*, ushort, ushort, ISC_SCHAR*);
ISC_STATUS isc_dsql_insert_m(ISC_STATUS*, isc_stmt_handle*, ushort, ISC_SCHAR*, ushort, ushort, ISC_SCHAR*);
ISC_STATUS isc_dsql_prepare_m(ISC_STATUS*, isc_tr_handle*, isc_stmt_handle*, ushort, ISC_SCHAR*, ushort, ushort, ISC_SCHAR*, ushort, ISC_SCHAR*);
ISC_STATUS isc_dsql_release(ISC_STATUS*, ISC_SCHAR*);
ISC_STATUS isc_embed_dsql_close(ISC_STATUS*, ISC_SCHAR*);
ISC_STATUS isc_embed_dsql_declare(ISC_STATUS*, ISC_SCHAR*, ISC_SCHAR*);
ISC_STATUS isc_embed_dsql_describe(ISC_STATUS*, ISC_SCHAR*, ushort, XSQLDA*);
ISC_STATUS isc_embed_dsql_describe_bind(ISC_STATUS*, ISC_SCHAR*, ushort, XSQLDA*);
ISC_STATUS isc_embed_dsql_execute(ISC_STATUS*, isc_tr_handle*, ISC_SCHAR*, ushort, XSQLDA*);
ISC_STATUS isc_embed_dsql_execute2(ISC_STATUS*, isc_tr_handle*, ISC_SCHAR*, ushort, XSQLDA*, XSQLDA*);
ISC_STATUS isc_embed_dsql_execute_immed(ISC_STATUS*, isc_db_handle*, isc_tr_handle*, ushort, ISC_SCHAR*, ushort, XSQLDA*);
ISC_STATUS isc_embed_dsql_fetch(ISC_STATUS*, ISC_SCHAR*, ushort, XSQLDA*);
ISC_STATUS isc_embed_dsql_open(ISC_STATUS*, isc_tr_handle*, ISC_SCHAR*, ushort, XSQLDA*);
ISC_STATUS isc_embed_dsql_open2(ISC_STATUS*, isc_tr_handle*, ISC_SCHAR*, ushort, XSQLDA*, XSQLDA*);
ISC_STATUS isc_embed_dsql_insert(ISC_STATUS*, ISC_SCHAR*, ushort, XSQLDA*);
ISC_STATUS isc_embed_dsql_prepare(ISC_STATUS*, isc_db_handle*, isc_tr_handle*, ISC_SCHAR*, ushort, ISC_SCHAR*, ushort, XSQLDA*);
ISC_STATUS isc_embed_dsql_release(ISC_STATUS*, ISC_SCHAR*);


/******************************/
/* Other Blob functions       */
/******************************/

BSTREAM* BLOB_open(isc_blob_handle, ISC_SCHAR*, int);
int BLOB_put(ISC_SCHAR, BSTREAM*);
int BLOB_close(BSTREAM*);
int BLOB_get(BSTREAM*);
int BLOB_display(ISC_QUAD*, isc_db_handle, isc_tr_handle, ISC_SCHAR*);
int BLOB_dump(ISC_QUAD*, isc_db_handle, isc_tr_handle, ISC_SCHAR*);
int BLOB_edit(ISC_QUAD*, isc_db_handle, isc_tr_handle, ISC_SCHAR*);
int BLOB_load(ISC_QUAD*, isc_db_handle, isc_tr_handle, ISC_SCHAR*);
int BLOB_text_dump(ISC_QUAD*, isc_db_handle, isc_tr_handle, ISC_SCHAR*);
int BLOB_text_load(ISC_QUAD*, isc_db_handle, isc_tr_handle, ISC_SCHAR*);
BSTREAM* Bopen(ISC_QUAD*, isc_db_handle, isc_tr_handle, ISC_SCHAR*);

/* Disabled, not found anywhere.
BSTREAM* ISC_EXPORT Bopen2(ISC_QUAD*, isc_db_handle, isc_tr_handle, ISC_SCHAR*, ushort);
*/

/******************************/
/* Other Misc functions       */
/******************************/

ISC_LONG isc_ftof(ISC_SCHAR*, ushort, ISC_SCHAR*, ushort);
//ISC_STATUS isc_print_blr(ISC_SCHAR*, FPTR_PRINT_CALLBACK*, void*, short);
void isc_set_debug(int);
void isc_qtoq(ISC_QUAD*, ISC_QUAD*);
void isc_vtof(ISC_SCHAR*, ISC_SCHAR*, ushort);
void isc_vtov(ISC_SCHAR*, ISC_SCHAR*, short);
//int isc_version(isc_db_handle*, FPTR_VERSION_CALLBACK*, void *);
ISC_LONG isc_reset_fpe(ISC_USHORT);


/*****************************************/
/* Service manager functions             */
/*****************************************/

//!!!!!!!!!!!!!!!!void ADD_SPB_LENGTH(void *p, int length) {*(p++) = length; p++ = length >> 8;}
//!!!!!!!!!!!!!!!!void ADD_SPB_NUMERIC(void *p, int data)  {*p++ = cast(SCHAR)data; *p++ = cast(SCHAR)(data >> 8); *p++ = cast(SCHAR)(data >> 16); *p++ = cast(SCHAR)(data >> 24);}
ISC_STATUS isc_service_attach(ISC_STATUS*, ushort, ISC_SCHAR*, isc_svc_handle*, ushort, ISC_SCHAR*);
ISC_STATUS isc_service_detach(ISC_STATUS *, isc_svc_handle *);
ISC_STATUS isc_service_query(ISC_STATUS*, isc_svc_handle*, isc_resv_handle*, ushort, ISC_SCHAR*, ushort, ISC_SCHAR*, ushort, ISC_SCHAR*);
ISC_STATUS isc_service_start(ISC_STATUS*, isc_svc_handle*, isc_resv_handle*, ushort, ISC_SCHAR*);


/********************************/
/* Client information functions */
/********************************/

void isc_get_client_version ( ISC_SCHAR  *);
int  isc_get_client_major_version ();
int  isc_get_client_minor_version ();

/***************************************************/
/* Actions to pass to the blob filter (ctl_source) */
/***************************************************/

const int isc_blob_filter_open = 0;
const int isc_blob_filter_get_segment = 1;
const int isc_blob_filter_close = 2;
const int isc_blob_filter_create = 3;
const int isc_blob_filter_put_segment = 4;
const int isc_blob_filter_alloc = 5;
const int isc_blob_filter_free = 6;
const int isc_blob_filter_seek = 7;

/*******************/
/* Blr definitions */
/*******************/


const int blr_text = cast(byte) 14;
const int blr_text2 = cast(byte) 15;
const int blr_short = cast(byte) 7;
const int blr_long = cast(byte) 8;
const int blr_quad = cast(byte) 9;
const int blr_float = cast(byte) 10;
const int blr_double = cast(byte) 27;
const int blr_d_float = cast(byte) 11;
const int blr_timestamp = cast(byte) 35;
const int blr_varying = cast(byte) 37;
const int blr_varying2 = cast(byte) 38;
const int blr_blob = cast(ushort)261;
const int blr_cstring = cast(byte) 40;
const int blr_cstring2 = cast(byte) 41;
const int blr_blob_id = cast(byte) 45;
const int blr_sql_date = cast(byte) 12;
const int blr_sql_time = cast(byte) 13;
const int blr_int64 = cast(byte) 16;
const int blr_date = blr_timestamp;
const int blr_inner = cast(byte) 0;
const int blr_left = cast(byte) 1;
const int blr_right = cast(byte) 2;
const int blr_full = cast(byte) 3;
const int blr_gds_code = cast(byte) 0;
const int blr_sql_code = cast(byte) 1;
const int blr_exception = cast(byte) 2;
const int blr_trigger_code = cast(byte) 3;
const int blr_default_code = cast(byte) 4;
const int blr_raise = cast(byte) 5;
const int blr_exception_msg = cast(byte) 6;
const int blr_version4 = cast(byte) 4;
const int blr_version5 = cast(byte) 5;
const int blr_eoc = cast(byte) 76;
const int blr_end = cast(byte) 255;
const int blr_assignment = cast(byte) 1;
const int blr_begin = cast(byte) 2;
const int blr_dcl_variable = cast(byte) 3;
const int blr_message = cast(byte) 4;
const int blr_erase = cast(byte) 5;
const int blr_fetch = cast(byte) 6;
const int blr_for = cast(byte) 7;
const int blr_if = cast(byte) 8;
const int blr_loop = cast(byte) 9;
const int blr_modify = cast(byte) 10;
const int blr_handler = cast(byte) 11;
const int blr_receive = cast(byte) 12;
const int blr_select = cast(byte) 13;
const int blr_send = cast(byte) 14;
const int blr_store = cast(byte) 15;
const int blr_label = cast(byte) 17;
const int blr_leave = cast(byte) 18;
const int blr_store2 = cast(byte) 19;
const int blr_post = cast(byte) 20;
const int blr_literal = cast(byte) 21;
const int blr_dbkey = cast(byte) 22;
const int blr_field = cast(byte) 23;
const int blr_fid = cast(byte) 24;
const int blr_parameter = cast(byte) 25;
const int blr_variable = cast(byte) 26;
const int blr_average = cast(byte) 27;
const int blr_count = cast(byte) 28;
const int blr_maximum = cast(byte) 29;
const int blr_minimum = cast(byte) 30;
const int blr_total = cast(byte) 31;
const int blr_add = cast(byte) 34;
const int blr_subtract = cast(byte) 35;
const int blr_multiply = cast(byte) 36;
const int blr_divide = cast(byte) 37;
const int blr_negate = cast(byte) 38;
const int blr_concatenate = cast(byte) 39;
const int blr_substring = cast(byte) 40;
const int blr_parameter2 = cast(byte) 41;
const int blr_from = cast(byte) 42;
const int blr_via = cast(byte) 43;
const int blr_parameter2_old = cast(byte) 44;
const int blr_user_name = cast(byte) 44;
const int blr_null = cast(byte) 45;
const int blr_equiv = cast(byte) 46;
const int blr_eql = cast(byte) 47;
const int blr_neq = cast(byte) 48;
const int blr_gtr = cast(byte) 49;
const int blr_geq = cast(byte) 50;
const int blr_lss = cast(byte) 51;
const int blr_leq = cast(byte) 52;
const int blr_containing = cast(byte) 53;
const int blr_matching = cast(byte) 54;
const int blr_starting = cast(byte) 55;
const int blr_between = cast(byte) 56;
const int blr_or = cast(byte) 57;
const int blr_and = cast(byte) 58;
const int blr_not = cast(byte) 59;
const int blr_any = cast(byte) 60;
const int blr_missing = cast(byte) 61;
const int blr_unique = cast(byte) 62;
const int blr_like = cast(byte) 63;
const int blr_stream = cast(byte) 65;
const int blr_set_index = cast(byte) 66;
const int blr_rse = cast(byte) 67;
const int blr_first = cast(byte) 68;
const int blr_project = cast(byte) 69;
const int blr_sort = cast(byte) 70;
const int blr_boolean = cast(byte) 71;
const int blr_ascending = cast(byte) 72;
const int blr_descending = cast(byte) 73;
const int blr_relation = cast(byte) 74;
const int blr_rid = cast(byte) 75;
const int blr_union = cast(byte) 76;
const int blr_map = cast(byte) 77;
const int blr_group_by = cast(byte) 78;
const int blr_aggregate = cast(byte) 79;
const int blr_join_type = cast(byte) 80;
const int blr_agg_count = cast(byte) 83;
const int blr_agg_max = cast(byte) 84;
const int blr_agg_min = cast(byte) 85;
const int blr_agg_total = cast(byte) 86;
const int blr_agg_average = cast(byte) 87;
const int blr_parameter3 = cast(byte) 88;
const int blr_run_max = cast(byte) 89;
const int blr_run_min = cast(byte) 90;
const int blr_run_total = cast(byte) 91;
const int blr_run_average = cast(byte) 92;
const int blr_agg_count2 = cast(byte) 93;
const int blr_agg_count_distinct= cast(byte) 94;
const int blr_agg_total_distinct= cast(byte) 95;
const int blr_agg_average_distinct = cast(byte) 96;
const int blr_function = cast(byte) 100;
const int blr_gen_id = cast(byte) 101;
const int blr_prot_mask = cast(byte) 102;
const int blr_upcase = cast(byte) 103;
const int blr_lock_state = cast(byte) 104;
const int blr_value_if = cast(byte) 105;
const int blr_matching2 = cast(byte) 106;
const int blr_index = cast(byte) 107;
const int blr_ansi_like = cast(byte) 108;
const int blr_bookmark = cast(byte) 109;
const int blr_crack = cast(byte) 110;
const int blr_force_crack = cast(byte) 111;
const int blr_seek = cast(byte) 112;
const int blr_find = cast(byte) 113;
const int blr_continue = cast(byte) 0;
const int blr_forward = cast(byte) 1;
const int blr_backward = cast(byte) 2;
const int blr_bof_forward = cast(byte) 3;
const int blr_eof_backward = cast(byte) 4;
const int blr_lock_relation = cast(byte) 114;
const int blr_lock_record = cast(byte) 115;
const int blr_set_bookmark = cast(byte) 116;
const int blr_get_bookmark = cast(byte) 117;
const int blr_run_count = cast(byte) 118;
const int blr_rs_stream = cast(byte) 119;
const int blr_exec_proc = cast(byte) 120;
const int blr_begin_range = cast(byte) 121;
const int blr_end_range = cast(byte) 122;
const int blr_delete_range = cast(byte) 123;
const int blr_procedure = cast(byte) 124;
const int blr_pid = cast(byte) 125;
const int blr_exec_pid = cast(byte) 126;
const int blr_singular = cast(byte) 127;
const int blr_abort = cast(byte) 128;
const int blr_block = cast(byte) 129;
const int blr_error_handler = cast(byte) 130;
const int blr_cast = cast(byte) 131;
const int blr_release_lock = cast(byte) 132;
const int blr_release_locks = cast(byte) 133;
const int blr_start_savepoint = cast(byte) 134;
const int blr_end_savepoint = cast(byte) 135;
const int blr_find_dbkey = cast(byte) 136;
const int blr_range_relation = cast(byte) 137;
const int blr_delete_ranges = cast(byte) 138;
const int blr_plan = cast(byte) 139;
const int blr_merge = cast(byte) 140;
const int blr_join = cast(byte) 141;
const int blr_sequential = cast(byte) 142;
const int blr_navigational = cast(byte) 143;
const int blr_indices = cast(byte) 144;
const int blr_retrieve = cast(byte) 145;
const int blr_relation2 = cast(byte) 146;
const int blr_rid2 = cast(byte) 147;
const int blr_reset_stream = cast(byte) 148;
const int blr_release_bookmark = cast(byte) 149;
const int blr_set_generator = cast(byte) 150;
const int blr_ansi_any = cast(byte) 151;
const int blr_exists = cast(byte) 152;
const int blr_cardinality = cast(byte) 153;
const int blr_record_version = cast(byte) 154;
const int blr_stall = cast(byte) 155;
const int blr_seek_no_warn = cast(byte) 156;
const int blr_find_dbkey_version= cast(byte) 157;
const int blr_ansi_all = cast(byte) 158;
const int blr_extract = cast(byte) 159;
const int blr_extract_year = cast(byte) 0;
const int blr_extract_month = cast(byte) 1;
const int blr_extract_day = cast(byte) 2;
const int blr_extract_hour = cast(byte) 3;
const int blr_extract_minute = cast(byte) 4;
const int blr_extract_second = cast(byte) 5;
const int blr_extract_weekday = cast(byte) 6;
const int blr_extract_yearday = cast(byte) 7;
const int blr_current_date = cast(byte) 160;
const int blr_current_timestamp = cast(byte) 161;
const int blr_current_time = cast(byte) 162;
const int blr_current_role = cast(byte) 174;
const int blr_skip = cast(byte) 175;
const int blr_exec_sql = cast(byte) 176;
const int blr_internal_info = cast(byte) 177;
const int blr_nullsfirst = cast(byte) 178;
const int blr_writelock = cast(byte) 179;
const int blr_nullslast = cast(byte) 180;
const int blr_post_arg = cast(byte) 163;
const int blr_exec_into = cast(byte) 164;
const int blr_user_savepoint = cast(byte) 165;
const int blr_dcl_cursor = cast(byte) 166;
const int blr_cursor_stmt = cast(byte) 167;
const int blr_savepoint_set = cast(byte) 0;
const int blr_savepoint_release = cast(byte) 1;
const int blr_savepoint_undo = cast(byte) 2;
const int blr_savepoint_release_single = cast(byte) 3;
const int blr_cursor_open = cast(byte) 0;
const int blr_cursor_close = cast(byte) 1;
const int blr_cursor_fetch = cast(byte) 2;


/*******************************=***/
/* Database parameter block stuf=f */
/**********************************/

const int isc_dpb_version1 = 1;
const int isc_dpb_cdd_pathname = 1;
const int isc_dpb_allocation = 2;
const int isc_dpb_journal = 3;
const int isc_dpb_page_size = 4;
const int isc_dpb_num_buffers = 5;
const int isc_dpb_buffer_length = 6;
const int isc_dpb_debug = 7;
const int isc_dpb_garbage_collect = 8;
const int isc_dpb_verify = 9;
const int isc_dpb_sweep = 10;
const int isc_dpb_enable_journal = 11;
const int isc_dpb_disable_journal = 12;
const int isc_dpb_dbkey_scope = 13;
const int isc_dpb_number_of_users = 14;
const int isc_dpb_trace = 15;
const int isc_dpb_no_garbage_collect = 16;
const int isc_dpb_damaged = 17;
const int isc_dpb_license = 18;
const int isc_dpb_sys_user_name = 19;
const int isc_dpb_encrypt_key = 20;
const int isc_dpb_activate_shadow = 21;
const int isc_dpb_sweep_interval = 22;
const int isc_dpb_delete_shadow = 23;
const int isc_dpb_force_write = 24;
const int isc_dpb_begin_log = 25;
const int isc_dpb_quit_log = 26;
const int isc_dpb_no_reserve = 27;
const int isc_dpb_user_name = 28;
const int isc_dpb_password = 29;
const int isc_dpb_password_enc = 30;
const int isc_dpb_sys_user_name_enc = 31;
const int isc_dpb_interp = 32;
const int isc_dpb_online_dump = 33;
const int isc_dpb_old_file_size = 34;
const int isc_dpb_old_num_files = 35;
const int isc_dpb_old_file = 36;
const int isc_dpb_old_start_page = 37;
const int isc_dpb_old_start_seqno = 38;
const int isc_dpb_old_start_file = 39;
const int isc_dpb_drop_walfile = 40;
const int isc_dpb_old_dump_id = 41;
const int isc_dpb_wal_backup_dir = 42;
const int isc_dpb_wal_chkptlen = 43;
const int isc_dpb_wal_numbufs = 44;
const int isc_dpb_wal_bufsize = 45;
const int isc_dpb_wal_grp_cmt_wait = 46;
const int isc_dpb_lc_messages = 47;
const int isc_dpb_lc_ctype = 48;
const int isc_dpb_cache_manager= 49;
const int isc_dpb_shutdown = 50;
const int isc_dpb_online = 51;
const int isc_dpb_shutdown_delay = 52;
const int isc_dpb_reserved = 53;
const int isc_dpb_overwrite = 54;
const int isc_dpb_sec_attach = 55;
const int isc_dpb_disable_wal = 56;
const int isc_dpb_connect_timeout = 57;
const int isc_dpb_dummy_packet_interval = 58;
const int isc_dpb_gbak_attach = 59;
const int isc_dpb_sql_role_name= 60;
const int isc_dpb_set_page_buffers = 61;
const int isc_dpb_working_directory = 62;
const int isc_dpb_sql_dialect = 63;
const int isc_dpb_set_db_readonly = 64;
const int isc_dpb_set_db_sql_dialect = 65;
const int isc_dpb_gfix_attach = 66;
const int isc_dpb_gstat_attach = 67;
const int isc_dpb_set_db_charset = 68;
const int isc_dpb_gsec_attach = 69;
const int isc_dpb_address_path = 70;

/**************************************************/
/* clumplet tags used inside isc_dpb_address_path */
/**************************************************/

/* Format of this clumplet is the following:

 <address-path-clumplet> ::=
  isc_dpb_address_path <byte-clumplet-length> <address-stack>

 <address-stack> ::=
  <address-descriptor> |
  <address-stack> <address-descriptor>

 <address-descriptor> ::=
  isc_dpb_address <byte-clumplet-length> <address-elements>

 <address-elements> ::=
  <address-element> |
  <address-elements> <address-element>

 <address-element> ::=
  isc_dpb_addr_protocol <byte-clumplet-length> <protocol-string> |
  isc_dpb_addr_endpoint <byte-clumplet-length> <remote-endpoint-string>

 <protocol-string> ::=
  "TCPv4" |
  "TCPv6" |
  "XNET" |
  "WNET" |
  ....

 <remote-endpoint-string> ::=
  <IPv4-address> | // such as "172.20.1.1"
  <IPv6-address> | // such as "2001:0:13FF:09FF::1"
  <xnet-process-id> | // such as "17864"
  ...
*/

const int isc_dpb_address = 1;
const int isc_dpb_addr_protocol= 1;
const int isc_dpb_addr_endpoint= 2;

/*********************************/
/* isc_dpb_verify specific flags */
/*********************************/

const int isc_dpb_pages = 1;
const int isc_dpb_records = 2;
const int isc_dpb_indices = 4;
const int isc_dpb_transactions = 8;
const int isc_dpb_no_update = 16;
const int isc_dpb_repair = 32;
const int isc_dpb_ignore = 64;

/***********************************/
/* isc_dpb_shutdown specific flags */
/***********************************/

const int isc_dpb_shut_cache = 0x1;
const int isc_dpb_shut_attachment = 0x2;
const int isc_dpb_shut_transaction = 0x4;
const int isc_dpb_shut_force = 0x8;
const int isc_dpb_shut_mode_mask = 0x70;
const int isc_dpb_shut_default = 0x0;
const int isc_dpb_shut_normal = 0x10;
const int isc_dpb_shut_multi = 0x20;
const int isc_dpb_shut_single = 0x30;
const int isc_dpb_shut_full = 0x40;
                                     
/**************************************/
/* Bit assignments in RDB$SYSTEM_FLAG */
/**************************************/

const int RDB_system = 1;
const int RDB_id_assigned = 2;
/* 2 is for QLI. See jrd/constants.h for more Firebird-specific values. */


/*************************************/
/* Transaction parameter block stuff */
/*************************************/

const int isc_tpb_version1 = 1;
const int isc_tpb_version3 = 3;
const int isc_tpb_consistency = 1;
const int isc_tpb_concurrency = 2;
const int isc_tpb_shared = 3;
const int isc_tpb_protected = 4;
const int isc_tpb_exclusive = 5;
const int isc_tpb_wait = 6;
const int isc_tpb_nowait = 7;
const int isc_tpb_read = 8;
const int isc_tpb_write = 9;
const int isc_tpb_lock_read = 10;
const int isc_tpb_lock_write = 11;
const int isc_tpb_verb_time = 12;
const int isc_tpb_commit_time = 13;
const int isc_tpb_ignore_limbo = 14;
const int isc_tpb_read_committed = 15;
const int isc_tpb_autocommit = 16;
const int isc_tpb_rec_version = 17;
const int isc_tpb_no_rec_version = 18;
const int isc_tpb_restart_requests = 19;
const int isc_tpb_no_auto_undo = 20;
const int isc_tpb_lock_timeout = 21;
                                      

/************************/
/* Blob Parameter Block */
/************************/

const int isc_bpb_version1 = 1;
const int isc_bpb_source_type = 1;
const int isc_bpb_target_type = 2;
const int isc_bpb_type = 3;
const int isc_bpb_source_interp = 4;
const int isc_bpb_target_interp = 5;
const int isc_bpb_filter_parameter = 6;
const int isc_bpb_type_segmented = 0;
const int isc_bpb_type_stream = 1;


/*********************************/
/* Service parameter block stuff */
/*********************************/

const int isc_spb_version1 = 1;
const int isc_spb_current_version = 2;
const int isc_spb_version = isc_spb_current_version;
const int isc_spb_user_name = isc_dpb_user_name;
const int isc_spb_sys_user_name = isc_dpb_sys_user_name;
const int isc_spb_sys_user_name_enc = isc_dpb_sys_user_name_enc;
const int isc_spb_password = isc_dpb_password;
const int isc_spb_password_enc = isc_dpb_password_enc;
const int isc_spb_command_line = 105;
const int isc_spb_dbname = 106;
const int isc_spb_verbose = 107;
const int isc_spb_options = 108;
const int isc_spb_connect_timeout = isc_dpb_connect_timeout;
const int isc_spb_dummy_packet_interval = isc_dpb_dummy_packet_interval;
const int isc_spb_sql_role_name = isc_dpb_sql_role_name;


/*********************************/
/* Information call declarations */
/*********************************/


const int isc_info_end = 1;
const int isc_info_truncated = 2;
const int isc_info_error = 3;
const int isc_info_data_not_ready = 4;
const int isc_info_flag_end = 127;
                                      
enum db_info_types
{
        isc_info_db_id = 4,
        isc_info_reads = 5,
        isc_info_writes = 6,
        isc_info_fetches = 7,
        isc_info_marks = 8,

        isc_info_implementation = 11,
        isc_info_isc_version = 12,
        isc_info_base_level = 13,
        isc_info_page_size = 14,
        isc_info_num_buffers = 15,
        isc_info_limbo = 16,
        isc_info_current_memory = 17,
        isc_info_max_memory = 18,
        isc_info_window_turns = 19,
        isc_info_license = 20,

        isc_info_allocation = 21,
        isc_info_attachment_id = 22,
        isc_info_read_seq_count = 23,
        isc_info_read_idx_count = 24,
        isc_info_insert_count = 25,
        isc_info_update_count = 26,
        isc_info_delete_count = 27,
        isc_info_backout_count = 28,
        isc_info_purge_count = 29,
        isc_info_expunge_count = 30,

        isc_info_sweep_interval = 31,
        isc_info_ods_version = 32,
        isc_info_ods_minor_version = 33,
        isc_info_no_reserve = 34,

        isc_info_logfile = 35,
        isc_info_cur_logfile_name = 36,
        isc_info_cur_log_part_offset = 37,
        isc_info_num_wal_buffers = 38,
        isc_info_wal_buffer_size = 39,
        isc_info_wal_ckpt_length = 40,

        isc_info_wal_cur_ckpt_interval = 41,
        isc_info_wal_prv_ckpt_fname = 42,
        isc_info_wal_prv_ckpt_poffset = 43,
        isc_info_wal_recv_ckpt_fname = 44,
        isc_info_wal_recv_ckpt_poffset = 45,
        isc_info_wal_grpc_wait_usecs = 47,
        isc_info_wal_num_io = 48,
        isc_info_wal_avg_io_size = 49,
        isc_info_wal_num_commits = 50,
        isc_info_wal_avg_grpc_size = 51,

        isc_info_forced_writes = 52,
        isc_info_user_names = 53,
        isc_info_page_errors = 54,
        isc_info_record_errors = 55,
        isc_info_bpage_errors = 56,
        isc_info_dpage_errors = 57,
        isc_info_ipage_errors = 58,
        isc_info_ppage_errors = 59,
        isc_info_tpage_errors = 60,

        isc_info_set_page_buffers = 61,
        isc_info_db_sql_dialect = 62,
        isc_info_db_read_only = 63,
        isc_info_db_size_in_pages = 64,

        frb_info_att_charset = 101,
        isc_info_db_class = 102,
        isc_info_firebird_version = 103,
        isc_info_oldest_transaction = 104,
        isc_info_oldest_active = 105,
        isc_info_oldest_snapshot = 106,
        isc_info_next_transaction = 107,
        isc_info_db_provider = 108,
        isc_info_active_transactions = 109,

        isc_info_db_last_value
};

const int isc_info_version = db_info_types.isc_info_isc_version;

enum  info_db_implementations
{
        isc_info_db_impl_rdb_vms = 1,
        isc_info_db_impl_rdb_eln = 2,
        isc_info_db_impl_rdb_eln_dev = 3,
        isc_info_db_impl_rdb_vms_y = 4,
        isc_info_db_impl_rdb_eln_y = 5,
        isc_info_db_impl_jri = 6,
        isc_info_db_impl_jsv = 7,

        isc_info_db_impl_isc_apl_68K = 25,
        isc_info_db_impl_isc_vax_ultr = 26,
        isc_info_db_impl_isc_vms = 27,
        isc_info_db_impl_isc_sun_68k = 28,
        isc_info_db_impl_isc_os2 = 29,
        isc_info_db_impl_isc_sun4 = 30,

        isc_info_db_impl_isc_hp_ux = 31,
        isc_info_db_impl_isc_sun_386i = 32,
        isc_info_db_impl_isc_vms_orcl = 33,
        isc_info_db_impl_isc_mac_aux = 34,
        isc_info_db_impl_isc_rt_aix = 35,
        isc_info_db_impl_isc_mips_ult = 36,
        isc_info_db_impl_isc_xenix = 37,
        isc_info_db_impl_isc_dg = 38,
        isc_info_db_impl_isc_hp_mpexl = 39,
        isc_info_db_impl_isc_hp_ux68K = 40,

        isc_info_db_impl_isc_sgi = 41,
        isc_info_db_impl_isc_sco_unix = 42,
        isc_info_db_impl_isc_cray = 43,
        isc_info_db_impl_isc_imp = 44,
        isc_info_db_impl_isc_delta = 45,
        isc_info_db_impl_isc_next = 46,
        isc_info_db_impl_isc_dos = 47,
        isc_info_db_impl_m88K = 48,
        isc_info_db_impl_unixware = 49,
        isc_info_db_impl_isc_winnt_x86 = 50,

        isc_info_db_impl_isc_epson = 51,
        isc_info_db_impl_alpha_osf = 52,
        isc_info_db_impl_alpha_vms = 53,
        isc_info_db_impl_netware_386 = 54,
        isc_info_db_impl_win_only = 55,
        isc_info_db_impl_ncr_3000 = 56,
        isc_info_db_impl_winnt_ppc = 57,
        isc_info_db_impl_dg_x86 = 58,
        isc_info_db_impl_sco_ev = 59,
        isc_info_db_impl_i386 = 60,

        isc_info_db_impl_freebsd = 61,
        isc_info_db_impl_netbsd = 62,
        isc_info_db_impl_darwin = 63,
        isc_info_db_impl_sinixz = 64,

        isc_info_db_impl_linux_sparc = 65,
        isc_info_db_impl_linux_amd64 = 66,

        isc_info_db_impl_last_value
};

const int isc_info_db_impl_isc_a = info_db_implementations.isc_info_db_impl_isc_apl_68K;
const int isc_info_db_impl_isc_u = info_db_implementations.isc_info_db_impl_isc_vax_ultr;
const int isc_info_db_impl_isc_v = info_db_implementations.isc_info_db_impl_isc_vms;
const int isc_info_db_impl_isc_s = info_db_implementations.isc_info_db_impl_isc_sun_68k;

enum info_db_class
{
        isc_info_db_class_access = 1,
        isc_info_db_class_y_valve = 2,
        isc_info_db_class_rem_int = 3,
        isc_info_db_class_rem_srvr = 4,
        isc_info_db_class_pipe_int = 7,
        isc_info_db_class_pipe_srvr = 8,
        isc_info_db_class_sam_int = 9,
        isc_info_db_class_sam_srvr = 10,
        isc_info_db_class_gateway = 11,
        isc_info_db_class_cache = 12,
        isc_info_db_class_classic_access = 13,
        isc_info_db_class_server_access = 14,

        isc_info_db_class_last_value
};

enum info_db_provider
{
        isc_info_db_code_rdb_eln = 1,
        isc_info_db_code_rdb_vms = 2,
        isc_info_db_code_interbase = 3,
        isc_info_db_code_firebird = 4,

        isc_info_db_code_last_value
};

const int isc_info_number_messages = 4;
const int isc_info_max_message = 5;
const int isc_info_max_send = 6;
const int isc_info_max_receive = 7;
const int isc_info_state = 8;
const int isc_info_message_number = 9;
const int isc_info_message_size = 10;
const int isc_info_request_cost = 11;
const int isc_info_access_path = 12;
const int isc_info_req_select_count = 13;
const int isc_info_req_insert_count = 14;
const int isc_info_req_update_count = 15;
const int isc_info_req_delete_count = 16;
const int isc_info_rsb_end = 0;
const int isc_info_rsb_begin = 1;
const int isc_info_rsb_type = 2;
const int isc_info_rsb_relation = 3;
const int isc_info_rsb_plan = 4;
const int isc_info_rsb_unknown = 1;
const int isc_info_rsb_indexed = 2;
const int isc_info_rsb_navigate = 3;
const int isc_info_rsb_sequential = 4;
const int isc_info_rsb_cross = 5;
const int isc_info_rsb_sort = 6;
const int isc_info_rsb_first = 7;
const int isc_info_rsb_boolean = 8;
const int isc_info_rsb_union = 9;
const int isc_info_rsb_aggregate = 10;
const int isc_info_rsb_merge = 11;
const int isc_info_rsb_ext_sequential = 12;
const int isc_info_rsb_ext_indexed = 13;
const int isc_info_rsb_ext_dbkey = 14;
const int isc_info_rsb_left_cross = 15;
const int isc_info_rsb_select = 16;
const int isc_info_rsb_sql_join = 17;
const int isc_info_rsb_simulate = 18;
const int isc_info_rsb_sim_cross = 19;
const int isc_info_rsb_once = 20;
const int isc_info_rsb_procedure = 21;
const int isc_info_rsb_skip = 22;
const int isc_info_rsb_and = 1;
const int isc_info_rsb_or = 2;
const int isc_info_rsb_dbkey = 3;
const int isc_info_rsb_index = 4;
const int isc_info_req_active = 2;
const int isc_info_req_inactive = 3;
const int isc_info_req_send = 4;
const int isc_info_req_receive = 5;
const int isc_info_req_select = 6;
const int isc_info_req_sql_stall = 7;
const int isc_info_blob_num_segments = 4;
const int isc_info_blob_max_segment = 5;
const int isc_info_blob_total_length = 6;
const int isc_info_blob_type = 7;
const int isc_info_tra_id = 4;
const int isc_info_sql_select = 4;
const int isc_info_sql_bind = 5;
const int isc_info_sql_num_variables = 6;
const int isc_info_sql_describe_vars = 7;
const int isc_info_sql_describe_end = 8;
const int isc_info_sql_sqlda_seq = 9;
const int isc_info_sql_message_seq = 10;
const int isc_info_sql_type = 11;
const int isc_info_sql_sub_type = 12;
const int isc_info_sql_scale = 13;
const int isc_info_sql_length = 14;
const int isc_info_sql_null_ind = 15;
const int isc_info_sql_field = 16;
const int isc_info_sql_relation = 17;
const int isc_info_sql_owner = 18;
const int isc_info_sql_alias = 19;
const int isc_info_sql_sqlda_start = 20;
const int isc_info_sql_stmt_type = 21;
const int isc_info_sql_get_plan = 22;
const int isc_info_sql_records = 23;
const int isc_info_sql_batch_fetch = 24;
const int isc_info_sql_relation_alias = 25;
const int isc_info_sql_stmt_select = 1;
const int isc_info_sql_stmt_insert = 2;
const int isc_info_sql_stmt_update = 3;
const int isc_info_sql_stmt_delete = 4;
const int isc_info_sql_stmt_ddl = 5;
const int isc_info_sql_stmt_get_segment = 6;
const int isc_info_sql_stmt_put_segment = 7;
const int isc_info_sql_stmt_exec_procedure= 8;
const int isc_info_sql_stmt_start_trans = 9;
const int isc_info_sql_stmt_commit = 10;
const int isc_info_sql_stmt_rollback = 11;
const int isc_info_sql_stmt_select_for_upd= 12;
const int isc_info_sql_stmt_set_generator = 13;
const int isc_info_sql_stmt_savepoint = 14;
                                          
                                          
                                          
/*****************************            
 * Service action items      *            
 *****************************/

const int isc_action_svc_backup = 1; /* Starts database backup process on the server */
const int isc_action_svc_restore = 2; /* Starts database restore process on the server */
const int isc_action_svc_repair = 3; /* Starts database repair process on the server */
const int isc_action_svc_add_user = 4; /* Adds a new user to the security database */
const int isc_action_svc_delete_user = 5; /* Deletes a user record from the security database */
const int isc_action_svc_modify_user = 6; /* Modifies a user record in the security database */
const int isc_action_svc_display_user = 7; /* Displays a user record from the security database */
const int isc_action_svc_properties = 8; /* Sets database properties */
const int isc_action_svc_add_license = 9; /* Adds a license to the license file */
const int isc_action_svc_remove_license = 10; /* Removes a license from the license file */
const int isc_action_svc_db_stats = 11; /* Retrieves database statistics */
const int isc_action_svc_get_ib_log = 12; /* Retrieves the InterBase log file from the server */
                                        
/*****************************          
 * Service information items *          
 *****************************/         
                                        
const int isc_info_svc_svr_db_info = 50; /* Retrieves the number of attachments and databases */
const int isc_info_svc_get_license = 51; /* Retrieves all license keys and IDs from the license file */
const int isc_info_svc_get_license_mask = 52; /* Retrieves a bitmask representing licensed options on the server */
const int isc_info_svc_get_config = 53; /* Retrieves the parameters and values for IB_CONFIG */
const int isc_info_svc_version = 54; /* Retrieves the version of the services manager */
const int isc_info_svc_server_version = 55; /* Retrieves the version of the InterBase server */
const int isc_info_svc_implementation = 56; /* Retrieves the implementation of the InterBase server */
const int isc_info_svc_capabilities = 57; /* Retrieves a bitmask representing the server's capabilities */
const int isc_info_svc_user_dbpath = 58; /* Retrieves the path to the security database in use by the server */
const int isc_info_svc_get_env = 59; /* Retrieves the setting of $INTERBASE */
const int isc_info_svc_get_env_lock = 60; /* Retrieves the setting of $INTERBASE_LCK */
const int isc_info_svc_get_env_msg = 61; /* Retrieves the setting of $INTERBASE_MSG */
const int isc_info_svc_line = 62; /* Retrieves 1 line of service output per call */
const int isc_info_svc_to_eof = 63; /* Retrieves as much of the server output as will fit in the supplied buffer */
const int isc_info_svc_timeout = 64; /* Sets / signifies a timeout value for reading service information */
const int isc_info_svc_get_licensed_users= 65; /* Retrieves the number of users licensed for accessing the server */
const int isc_info_svc_limbo_trans = 66; /* Retrieve the limbo transactions */
const int isc_info_svc_running = 67; /* Checks to see if a service is running on an attachment */
const int isc_info_svc_get_users = 68; /* Returns the user information from isc_action_svc_display_users */

/******************************************************
 * Parameters for isc_action_{add|del|mod|disp)_user  *
 ******************************************************/

const int isc_spb_sec_userid = 5;
const int isc_spb_sec_groupid = 6;
const int isc_spb_sec_username = 7;
const int isc_spb_sec_password = 8;
const int isc_spb_sec_groupname = 9;
const int isc_spb_sec_firstname = 10;
const int isc_spb_sec_middlename = 11;
const int isc_spb_sec_lastname = 12;

/*******************************************************
 * Parameters for isc_action_svc_(add|remove)_license, *
 * isc_info_svc_get_license                            *
 *******************************************************/

const int isc_spb_lic_key = 5;
const int isc_spb_lic_id = 6;
const int isc_spb_lic_desc = 7;

/*****************************************
 * Parameters for isc_action_svc_backup  *
 *****************************************/

const int isc_spb_bkp_file = 5;
const int isc_spb_bkp_factor = 6;
const int isc_spb_bkp_length = 7;
const int isc_spb_bkp_ignore_checksums = 0x01;
const int isc_spb_bkp_ignore_limbo = 0x02;
const int isc_spb_bkp_metadata_only = 0x04;
const int isc_spb_bkp_no_garbage_collect = 0x08;
const int isc_spb_bkp_old_descriptions = 0x10;
const int isc_spb_bkp_non_transportable = 0x20;
const int isc_spb_bkp_convert = 0x40;
const int isc_spb_bkp_expand = 0x80;
                                         
/********************************************
 * Parameters for isc_action_svc_properties *
 ********************************************/

const int isc_spb_prp_page_buffers = 5;
const int isc_spb_prp_sweep_interval = 6;
const int isc_spb_prp_shutdown_db = 7;
const int isc_spb_prp_deny_new_attachments = 9;
const int isc_spb_prp_deny_new_transactions = 10;
const int isc_spb_prp_reserve_space = 11;
const int isc_spb_prp_write_mode = 12;
const int isc_spb_prp_access_mode = 13;
const int isc_spb_prp_set_sql_dialect = 14;
const int isc_spb_prp_activate = 0x0100;
const int isc_spb_prp_db_online = 0x0200;

/********************************************
 * Parameters for isc_spb_prp_reserve_space *
 ********************************************/

const int isc_spb_prp_res_use_full = 35;
const int isc_spb_prp_res = 36;

/******************************************
 * Parameters for isc_spb_prp_write_mode  *
 ******************************************/

const int isc_spb_prp_wm_async = 37;
const int isc_spb_prp_wm_sync = 38;

/******************************************
 * Parameters for isc_spb_prp_access_mode *
 ******************************************/

const int isc_spb_prp_am_readonly = 39;
const int isc_spb_prp_am_readwrite = 40;

/*****************************************
 * Parameters for isc_action_svc_repair  *
 *****************************************/

const int isc_spb_rpr_commit_trans = 15;
const int isc_spb_rpr_rollback_trans = 34;
const int isc_spb_rpr_recover_two_phase = 17;
const int isc_spb_tra_id = 18;
const int isc_spb_single_tra_id = 19;
const int isc_spb_multi_tra_id = 20;
const int isc_spb_tra_state = 21;
const int isc_spb_tra_state_limbo = 22;
const int isc_spb_tra_state_commit = 23;
const int isc_spb_tra_state_rollback = 24;
const int isc_spb_tra_state_unknown = 25;
const int isc_spb_tra_host_site = 26;
const int isc_spb_tra_remote_site = 27;
const int isc_spb_tra_db_path = 28;
const int isc_spb_tra_advise = 29;
const int isc_spb_tra_advise_commit = 30;
const int isc_spb_tra_advise_rollback = 31;
const int isc_spb_tra_advise_unknown = 33;
const int isc_spb_rpr_validate_db = 0x01;
const int isc_spb_rpr_sweep_db = 0x02;
const int isc_spb_rpr_mend_db = 0x04;
const int isc_spb_rpr_list_limbo_trans = 0x08;
const int isc_spb_rpr_check_db = 0x10;
const int isc_spb_rpr_ignore_checksum = 0x20;
const int isc_spb_rpr_kill_shadows = 0x40;
const int isc_spb_rpr_full = 0x80;

/*****************************************
 * Parameters for isc_action_svc_restore *
 *****************************************/

const int isc_spb_res_buffers = 9;
const int isc_spb_res_page_size = 10;
const int isc_spb_res_length = 11;
const int isc_spb_res_access_mode = 12;
const int isc_spb_res_deactivate_idx = 0x0100;
const int isc_spb_res_no_shadow = 0x0200;
const int isc_spb_res_no_validity = 0x0400;
const int isc_spb_res_one_at_a_time = 0x0800;
const int isc_spb_res_replace = 0x1000;
const int isc_spb_res_create = 0x2000;
const int isc_spb_res_use_all_space = 0x4000;

/******************************************
 * Parameters for isc_spb_res_access_mode  *
 ******************************************/

const int isc_spb_res_am_readonly = isc_spb_prp_am_readonly;
const int isc_spb_res_am_readwrite = isc_spb_prp_am_readwrite;

/*******************************************
 * Parameters for isc_info_svc_svr_db_info *
 *******************************************/

const int isc_spb_num_att = 5;
const int isc_spb_num_db = 6;

/*****************************************
 * Parameters for isc_info_svc_db_stats  *
 *****************************************/

const int isc_spb_sts_data_pages = 0x01;
const int isc_spb_sts_db_log = 0x02;
const int isc_spb_sts_hdr_pages = 0x04;
const int isc_spb_sts_idx_pages = 0x08;
const int isc_spb_sts_sys_relations= 0x10;
const int isc_spb_sts_record_versions = 0x20;
const int isc_spb_sts_table = 0x40;
const int isc_spb_sts_nocreation = 0x80;

/***********************************/
/* Server configuration key values */
/***********************************/

/* Not available in Firebird 1.5 */


/**********************************************/
/* Dynamic Data Definition Language operators */
/**********************************************/

/******************/
/* Version number */
/******************/

const int isc_dyn_version_1 = 1;
const int isc_dyn_eoc = 255;

/******************************/
/* Operations (may be nested) */
/******************************/

const int isc_dyn_begin = 2;
const int isc_dyn_end = 3;
const int isc_dyn_if = 4;
const int isc_dyn_def_database = 5;
const int isc_dyn_def_global_fld = 6;
const int isc_dyn_def_local_fld = 7;
const int isc_dyn_def_idx = 8;
const int isc_dyn_def_rel = 9;
const int isc_dyn_def_sql_fld = 10;
const int isc_dyn_def_view = 12;
const int isc_dyn_def_trigger = 15;
const int isc_dyn_def_security_class = 120;
const int isc_dyn_def_dimension = 140;
const int isc_dyn_def_generator = 24;
const int isc_dyn_def_function = 25;
const int isc_dyn_def_filter = 26;
const int isc_dyn_def_function_arg = 27;
const int isc_dyn_def_shadow = 34;
const int isc_dyn_def_trigger_msg = 17;
const int isc_dyn_def_file = 36;
const int isc_dyn_mod_database = 39;
const int isc_dyn_mod_rel = 11;
const int isc_dyn_mod_global_fld = 13;
const int isc_dyn_mod_idx = 102;
const int isc_dyn_mod_local_fld = 14;
const int isc_dyn_mod_sql_fld = 216;
const int isc_dyn_mod_view = 16;
const int isc_dyn_mod_security_class = 122;
const int isc_dyn_mod_trigger = 113;
const int isc_dyn_mod_trigger_msg = 28;
const int isc_dyn_delete_database = 18;
const int isc_dyn_delete_rel = 19;
const int isc_dyn_delete_global_fld = 20;
const int isc_dyn_delete_local_fld = 21;
const int isc_dyn_delete_idx = 22;
const int isc_dyn_delete_security_class = 123;
const int isc_dyn_delete_dimensions = 143;
const int isc_dyn_delete_trigger = 23;
const int isc_dyn_delete_trigger_msg = 29;
const int isc_dyn_delete_filter = 32;
const int isc_dyn_delete_function = 33;
const int isc_dyn_delete_shadow = 35;
const int isc_dyn_grant = 30;
const int isc_dyn_revoke = 31;
const int isc_dyn_def_primary_key = 37;
const int isc_dyn_def_foreign_key = 38;
const int isc_dyn_def_unique = 40;
const int isc_dyn_def_procedure = 164;
const int isc_dyn_delete_procedure = 165;
const int isc_dyn_def_parameter = 135;
const int isc_dyn_delete_parameter = 136;
const int isc_dyn_mod_procedure = 175;
/* Deprecated.
int isc_dyn_def_log_file              176;
int isc_dyn_def_cache_file            180;
*/
const int isc_dyn_def_exception = 181;
const int isc_dyn_mod_exception = 182;
const int isc_dyn_del_exception = 183;
/* Deprecated.
int isc_dyn_drop_log                  194;
int isc_dyn_drop_cache                195;
int isc_dyn_def_default_log           202;
*/
const int isc_dyn_def_difference = 220;
const int isc_dyn_drop_difference = 221;
const int isc_dyn_begin_backup = 222;
const int isc_dyn_end_backup = 223;

/***********************/
/* View specific stuff */
/***********************/

const int isc_dyn_view_blr = 43;
const int isc_dyn_view_source = 44;
const int isc_dyn_view_relation = 45;
const int isc_dyn_view_context = 46;
const int isc_dyn_view_context_name = 47;

/**********************/
/* Generic attributes */
/**********************/

const int isc_dyn_rel_name = 50;
const int isc_dyn_fld_name = 51;
const int isc_dyn_new_fld_name = 215;
const int isc_dyn_idx_name = 52;
const int isc_dyn_description = 53;
const int isc_dyn_security_class = 54;
const int isc_dyn_system_flag = 55;
const int isc_dyn_update_flag = 56;
const int isc_dyn_prc_name = 166;
const int isc_dyn_prm_name = 137;
const int isc_dyn_sql_object = 196;
const int isc_dyn_fld_character_set_name = 174;

/********************************/
/* Relation specific attributes */
/********************************/

const int isc_dyn_rel_dbkey_length = 61;
const int isc_dyn_rel_store_trig = 62;
const int isc_dyn_rel_modify_trig = 63;
const int isc_dyn_rel_erase_trig = 64;
const int isc_dyn_rel_store_trig_source = 65;
const int isc_dyn_rel_modify_trig_source = 66;
const int isc_dyn_rel_erase_trig_source = 67;
const int isc_dyn_rel_ext_file = 68;
const int isc_dyn_rel_sql_protection = 69;
const int isc_dyn_rel_constraint = 162;
const int isc_dyn_delete_rel_constraint = 163;

/************************************/
/* Global field specific attributes */
/************************************/

const int isc_dyn_fld_type = 70;
const int isc_dyn_fld_length = 71;
const int isc_dyn_fld_scale = 72;
const int isc_dyn_fld_sub_type = 73;
const int isc_dyn_fld_segment_length = 74;
const int isc_dyn_fld_query_header = 75;
const int isc_dyn_fld_edit_string = 76;
const int isc_dyn_fld_validation_blr = 77;
const int isc_dyn_fld_validation_source = 78;
const int isc_dyn_fld_computed_blr = 79;
const int isc_dyn_fld_computed_source = 80;
const int isc_dyn_fld_missing_value = 81;
const int isc_dyn_fld_default_value = 82;
const int isc_dyn_fld_query_name = 83;
const int isc_dyn_fld_dimensions = 84;
const int isc_dyn_fld_not_null = 85;
const int isc_dyn_fld_precision = 86;
const int isc_dyn_fld_char_length = 172;
const int isc_dyn_fld_collation = 173;
const int isc_dyn_fld_default_source = 193;
const int isc_dyn_del_default = 197;
const int isc_dyn_del_validation = 198;
const int isc_dyn_single_validation = 199;
const int isc_dyn_fld_character_set = 203;

/***********************************/
/* Local field specific attributes */
/***********************************/

const int isc_dyn_fld_source = 90;
const int isc_dyn_fld_base_fld = 91;
const int isc_dyn_fld_position = 92;
const int isc_dyn_fld_update_flag = 93;

/*****************************/
/* Index specific attributes */
/*****************************/

const int isc_dyn_idx_unique = 100;
const int isc_dyn_idx_inactive = 101;
const int isc_dyn_idx_type = 103;
const int isc_dyn_idx_foreign_key = 104;
const int isc_dyn_idx_ref_column = 105;
const int isc_dyn_idx_statistic = 204;

/*******************************/
/* Trigger specific attributes */
/*******************************/

const int isc_dyn_trg_type = 110;
const int isc_dyn_trg_blr = 111;
const int isc_dyn_trg_source = 112;
const int isc_dyn_trg_name = 114;
const int isc_dyn_trg_sequence = 115;
const int isc_dyn_trg_inactive = 116;
const int isc_dyn_trg_msg_number = 117;
const int isc_dyn_trg_msg = 118;

/**************************************/
/* Security Class specific attributes */
/**************************************/

const int isc_dyn_scl_acl = 121;
const int isc_dyn_grant_user = 130;
const int isc_dyn_grant_user_explicit = 219;
const int isc_dyn_grant_proc = 186;
const int isc_dyn_grant_trig = 187;
const int isc_dyn_grant_view = 188;
const int isc_dyn_grant_options = 132;
const int isc_dyn_grant_user_group = 205;
const int isc_dyn_grant_role = 218;


/**********************************/
/* Dimension specific information */
/**********************************/

const int isc_dyn_dim_lower = 141;
const int isc_dyn_dim_upper = 142;

/****************************/
/* File specific attributes */
/****************************/

const int isc_dyn_file_name = 125;
const int isc_dyn_file_start = 126;
const int isc_dyn_file_length = 127;
const int isc_dyn_shadow_number = 128;
const int isc_dyn_shadow_man_auto = 129;
const int isc_dyn_shadow_conditional = 130;

/********************************/
/* Log file specific attributes */
/********************************/
/* Deprecated.
int isc_dyn_log_file_sequence         177;
int isc_dyn_log_file_partitions       178;
int isc_dyn_log_file_serial           179;
int isc_dyn_log_file_overflow         200;
int isc_dyn_log_file_raw      201;
*/

/***************************/
/* Log specific attributes */
/***************************/
/* Deprecated.
int isc_dyn_log_group_commit_wait     189;
int isc_dyn_log_buffer_size           190;
int isc_dyn_log_check_point_length    191;
int isc_dyn_log_num_of_buffers        192;
*/

/********************************/
/* Function specific attributes */
/********************************/

const int isc_dyn_function_name = 145;
const int isc_dyn_function_type = 146;
const int isc_dyn_func_module_name = 147;
const int isc_dyn_func_entry_point = 148;
const int isc_dyn_func_return_argument = 149;
const int isc_dyn_func_arg_position = 150;
const int isc_dyn_func_mechanism = 151;
const int isc_dyn_filter_in_subtype = 152;
const int isc_dyn_filter_out_subtype = 153;
const int isc_dyn_description2 = 154;
const int isc_dyn_fld_computed_source2 = 155;
const int isc_dyn_fld_edit_string2 = 156;
const int isc_dyn_fld_query_header2 = 157;
const int isc_dyn_fld_validation_source2 = 158;
const int isc_dyn_trg_msg2 = 159;
const int isc_dyn_trg_source2 = 160;
const int isc_dyn_view_source2 = 161;
const int isc_dyn_xcp_msg2 = 184;

/*********************************/
/* Generator specific attributes */
/*********************************/

const int isc_dyn_generator_name = 95;
const int isc_dyn_generator_id = 96;

/*********************************/
/* Procedure specific attributes */
/*********************************/

const int isc_dyn_prc_inputs = 167;
const int isc_dyn_prc_outputs = 168;
const int isc_dyn_prc_source = 169;
const int isc_dyn_prc_blr = 170;
const int isc_dyn_prc_source2 = 171;

/*********************************/
/* Parameter specific attributes */
/*********************************/

const int isc_dyn_prm_number = 138;
const int isc_dyn_prm_type = 139;

/********************************/
/* Relation specific attributes */
/********************************/

const int isc_dyn_xcp_msg = 185;

/**********************************************/
/* Cascading referential integrity values     */
/**********************************************/
const int isc_dyn_foreign_key_update = 205;
const int isc_dyn_foreign_key_delete = 206;
const int isc_dyn_foreign_key_cascade = 207;
const int isc_dyn_foreign_key_default = 208;
const int isc_dyn_foreign_key_null = 209;
const int isc_dyn_foreign_key_none = 210;

/***********************/
/* SQL role values     */
/***********************/
const int isc_dyn_def_sql_role = 211;
const int isc_dyn_sql_role_name = 212;
const int isc_dyn_grant_admin_options = 213;
const int isc_dyn_del_sql_role = 214;
/* 215 & 216 are used some lines above. */

/**********************************************/
/* Generators again                           */
/**********************************************/

const int isc_dyn_delete_generator = 217;

/****************************/
/* Last $dyn value assigned */
/****************************/

const int isc_dyn_last_dyn_value = 223;

/******************************************/
/* Array slice description language (SDL) */
/******************************************/

const int isc_sdl_version1 = 1;
const int isc_sdl_eoc = 255;
const int isc_sdl_relation = 2;
const int isc_sdl_rid = 3;
const int isc_sdl_field = 4;
const int isc_sdl_fid = 5;
const int isc_sdl_struct = 6;
const int isc_sdl_variable = 7;
const int isc_sdl_scalar = 8;
const int isc_sdl_tiny_integer = 9;
const int isc_sdl_short_integer = 10;
const int isc_sdl_long_integer = 11;
const int isc_sdl_literal = 12;
const int isc_sdl_add = 13;
const int isc_sdl_subtract = 14;
const int isc_sdl_multiply = 15;
const int isc_sdl_divide = 16;
const int isc_sdl_negate = 17;
const int isc_sdl_eql = 18;
const int isc_sdl_neq = 19;
const int isc_sdl_gtr = 20;
const int isc_sdl_geq = 21;
const int isc_sdl_lss = 22;
const int isc_sdl_leq = 23;
const int isc_sdl_and = 24;
const int isc_sdl_or = 25;
const int isc_sdl_not = 26;
const int isc_sdl_while = 27;
const int isc_sdl_assignment = 28;
const int isc_sdl_label = 29;
const int isc_sdl_leave = 30;
const int isc_sdl_begin = 31;
const int isc_sdl_end = 32;
const int isc_sdl_do3 = 33;
const int isc_sdl_do2 = 34;
const int isc_sdl_do1 = 35;
const int isc_sdl_element = 36;

/********************************************/
/* International text interpretation values */
/********************************************/

const int isc_interp_eng_ascii = 0;
const int isc_interp_jpn_sjis = 5;
const int isc_interp_jpn_euc = 6;

/*****************/
/* Blob Subtypes */
/*****************/

/* types less than zero are reserved for customer use */

const int isc_blob_untyped = 0;

/* internal subtypes */

const int isc_blob_text = 1;
const int isc_blob_blr = 2;
const int isc_blob_acl = 3;
const int isc_blob_ranges = 4;
const int isc_blob_summary = 5;
const int isc_blob_format = 6;
const int isc_blob_tra = 7;
const int isc_blob_extfile = 8;
const int isc_blob_max_predefined_subtype = 9;

/* the range 20-30 is reserved for dBASE and Paradox types */

const int isc_blob_formatted_memo = 20;
const int isc_blob_paradox_ole = 21;
const int isc_blob_graphic = 22;
const int isc_blob_dbase_ole = 23;
const int isc_blob_typed_binary = 24;

/* Deprecated definitions maintained for compatibility only */

const int isc_info_db_SQL_dialect = 62;
const int isc_dpb_SQL_dialect = 63;
const int isc_dpb_set_db_SQL_dialect = 65;

/*
 * The contents of this file are subject to the Interbase Public
 * License Version 1.0 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy
 * of the License at http://www.Inprise.com/IPL.html
 *
 * Software distributed under the License is distributed on an
 * "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express
 * or implied. See the License for the specific language governing
 * rights and limitations under the License.
 *
 * The content of this file was generated by the Firebird project
 * using the program jrd/codes.epp
 */
/*
 *
 * *** WARNING *** - This file is automatically generated by codes.epp - do not edit!
 *
 */
/*
 *  MODULE:   iberror.h
 *  DESCRIPTION:  ISC error codes
 *
 */



/***********************/
/*   ISC Error Codes   */
/***********************/



const int isc_facility = 20;
const int isc_base = 335544320L;
const int isc_factor = 1;
const int isc_arg_end = 0;  /* end of argument list */
const int isc_arg_gds = 1; /* generic DSRI status value */
const int isc_arg_string = 2;  /* string argument */
const int isc_arg_cstring = 3;  /* count & string argument */
const int isc_arg_number = 4;  /* numeric argument (int) */
const int isc_arg_interpreted = 5;  /* interpreted status code (string) */
const int isc_arg_vms  = 6;  /* VAX/VMS status code (int) */
const int isc_arg_unix = 7;  /* UNIX error code */
const int isc_arg_domain = 8;  /* Apollo/Domain error code */
const int isc_arg_dos = 9;  /* MSDOS/OS2 error code */
const int isc_arg_mpexl = 10;  /* HP MPE/XL error code */
const int isc_arg_mpexl_ipc = 11;  /* HP MPE/XL IPC error code */
const int isc_arg_next_mach = 15;  /* NeXT/Mach error code */
const int isc_arg_netware = 16;  /* NetWare error code */
const int isc_arg_win32 = 17;  /* Win32 error code */
const int isc_arg_warning = 18;  /* warning argument */
const int isc_arith_except = 335544321L;
const int isc_bad_dbkey = 335544322L;
const int isc_bad_db_format = 335544323L;
const int isc_bad_db_handle = 335544324L;
const int isc_bad_dpb_content = 335544325L;
const int isc_bad_dpb_form = 335544326L;
const int isc_bad_req_handle = 335544327L;
const int isc_bad_segstr_handle = 335544328L;
const int isc_bad_segstr_id = 335544329L;
const int isc_bad_tpb_content = 335544330L;
const int isc_bad_tpb_form = 335544331L;
const int isc_bad_trans_handle = 335544332L;
const int isc_bug_check = 335544333L;
const int isc_convert_error = 335544334L;
const int isc_db_corrupt = 335544335L;
const int isc_deadlock = 335544336L;
const int isc_excess_trans = 335544337L;
const int isc_from_no_match = 335544338L;
const int isc_infinap = 335544339L;
const int isc_infona = 335544340L;
const int isc_infunk = 335544341L;
const int isc_integ_fail = 335544342L;
const int isc_invalid_blr = 335544343L;
const int isc_io_error = 335544344L;
const int isc_lock_conflict = 335544345L;
const int isc_metadata_corrupt = 335544346L;
const int isc_not_valid = 335544347L;
const int isc_no_cur_rec = 335544348L;
const int isc_no_dup = 335544349L;
const int isc_no_finish = 335544350L;
const int isc_no_meta_update = 335544351L;
const int isc_no_priv = 335544352L;
const int isc_no_recon = 335544353L;
const int isc_no_record = 335544354L;
const int isc_no_segstr_close = 335544355L;
const int isc_obsolete_metadata = 335544356L;
const int isc_open_trans = 335544357L;
const int isc_port_len = 335544358L;
const int isc_read_only_field = 335544359L;
const int isc_read_only_rel = 335544360L;
const int isc_read_only_trans = 335544361L;
const int isc_read_only_view = 335544362L;
const int isc_req_no_trans = 335544363L;
const int isc_req_sync = 335544364L;
const int isc_req_wrong_db = 335544365L;
const int isc_segment = 335544366L;
const int isc_segstr_eof = 335544367L;
const int isc_segstr_no_op = 335544368L;
const int isc_segstr_no_read = 335544369L;
const int isc_segstr_no_trans = 335544370L;
const int isc_segstr_no_write = 335544371L;
const int isc_segstr_wrong_db = 335544372L;
const int isc_sys_request = 335544373L;
const int isc_stream_eof = 335544374L;
const int isc_unavailable = 335544375L;
const int isc_unres_rel = 335544376L;
const int isc_uns_ext = 335544377L;
const int isc_wish_list = 335544378L;
const int isc_wrong_ods = 335544379L;
const int isc_wronumarg = 335544380L;
const int isc_imp_exc = 335544381L;
const int isc_random = 335544382L;
const int isc_fatal_conflict = 335544383L;
const int isc_badblk = 335544384L;
const int isc_invpoolcl = 335544385L;
const int isc_nopoolids = 335544386L;
const int isc_relbadblk = 335544387L;
const int isc_blktoobig = 335544388L;
const int isc_bufexh = 335544389L;
const int isc_syntaxerr = 335544390L;
const int isc_bufinuse = 335544391L;
const int isc_bdbincon = 335544392L;
const int isc_reqinuse = 335544393L;
const int isc_badodsver = 335544394L;
const int isc_relnotdef = 335544395L;
const int isc_fldnotdef = 335544396L;
const int isc_dirtypage = 335544397L;
const int isc_waifortra = 335544398L;
const int isc_doubleloc = 335544399L;
const int isc_nodnotfnd = 335544400L;
const int isc_dupnodfnd = 335544401L;
const int isc_locnotmar = 335544402L;
const int isc_badpagtyp = 335544403L;
const int isc_corrupt = 335544404L;
const int isc_badpage = 335544405L;
const int isc_badindex = 335544406L;
const int isc_dbbnotzer = 335544407L;
const int isc_tranotzer = 335544408L;
const int isc_trareqmis = 335544409L;
const int isc_badhndcnt = 335544410L;
const int isc_wrotpbver = 335544411L;
const int isc_wroblrver = 335544412L;
const int isc_wrodpbver = 335544413L;
const int isc_blobnotsup = 335544414L;
const int isc_badrelation = 335544415L;
const int isc_nodetach = 335544416L;
const int isc_notremote = 335544417L;
const int isc_trainlim = 335544418L;
const int isc_notinlim = 335544419L;
const int isc_traoutsta = 335544420L;
const int isc_connect_reject = 335544421L;
const int isc_dbfile = 335544422L;
const int isc_orphan = 335544423L;
const int isc_no_lock_mgr = 335544424L;
const int isc_ctxinuse = 335544425L;
const int isc_ctxnotdef = 335544426L;
const int isc_datnotsup = 335544427L;
const int isc_badmsgnum = 335544428L;
const int isc_badparnum = 335544429L;
const int isc_virmemexh = 335544430L;
const int isc_blocking_signal = 335544431L;
const int isc_lockmanerr = 335544432L;
const int isc_journerr = 335544433L;
const int isc_keytoobig = 335544434L;
const int isc_nullsegkey = 335544435L;
const int isc_sqlerr = 335544436L;
const int isc_wrodynver = 335544437L;
const int isc_funnotdef = 335544438L;
const int isc_funmismat = 335544439L;
const int isc_bad_msg_vec = 335544440L;
const int isc_bad_detach = 335544441L;
const int isc_noargacc_read = 335544442L;
const int isc_noargacc_write = 335544443L;
const int isc_read_only = 335544444L;
const int isc_ext_err = 335544445L;
const int isc_non_updatable = 335544446L;
const int isc_no_rollback = 335544447L;
const int isc_bad_sec_info = 335544448L;
const int isc_invalid_sec_info = 335544449L;
const int isc_misc_interpreted = 335544450L;
const int isc_update_conflict = 335544451L;
const int isc_unlicensed = 335544452L;
const int isc_obj_in_use = 335544453L;
const int isc_nofilter = 335544454L;
const int isc_shadow_accessed = 335544455L;
const int isc_invalid_sdl = 335544456L;
const int isc_out_of_bounds = 335544457L;
const int isc_invalid_dimension = 335544458L;
const int isc_rec_in_limbo = 335544459L;
const int isc_shadow_missing = 335544460L;
const int isc_cant_validate = 335544461L;
const int isc_cant_start_journal = 335544462L;
const int isc_gennotdef = 335544463L;
const int isc_cant_start_logging = 335544464L;
const int isc_bad_segstr_type = 335544465L;
const int isc_foreign_key = 335544466L;
const int isc_high_minor = 335544467L;
const int isc_tra_state = 335544468L;
const int isc_trans_invalid = 335544469L;
const int isc_buf_invalid = 335544470L;
const int isc_indexnotdefined = 335544471L;
const int isc_login = 335544472L;
const int isc_invalid_bookmark = 335544473L;
const int isc_bad_lock_level = 335544474L;
const int isc_relation_lock = 335544475L;
const int isc_record_lock = 335544476L;
const int isc_max_idx = 335544477L;
const int isc_jrn_enable = 335544478L;
const int isc_old_failure = 335544479L;
const int isc_old_in_progress = 335544480L;
const int isc_old_no_space = 335544481L;
const int isc_no_wal_no_jrn = 335544482L;
const int isc_num_old_files = 335544483L;
const int isc_wal_file_open = 335544484L;
const int isc_bad_stmt_handle = 335544485L;
const int isc_wal_failure = 335544486L;
const int isc_walw_err = 335544487L;
const int isc_logh_small = 335544488L;
const int isc_logh_inv_version = 335544489L;
const int isc_logh_open_flag = 335544490L;
const int isc_logh_open_flag2 = 335544491L;
const int isc_logh_diff_dbname = 335544492L;
const int isc_logf_unexpected_eof = 335544493L;
const int isc_logr_incomplete = 335544494L;
const int isc_logr_header_small = 335544495L;
const int isc_logb_small = 335544496L;
const int isc_wal_illegal_attach = 335544497L;
const int isc_wal_invalid_wpb = 335544498L;
const int isc_wal_err_rollover = 335544499L;
const int isc_no_wal = 335544500L;
const int isc_drop_wal = 335544501L;
const int isc_stream_not_defined = 335544502L;
const int isc_wal_subsys_error = 335544503L;
const int isc_wal_subsys_corrupt = 335544504L;
const int isc_no_archive = 335544505L;
const int isc_shutinprog = 335544506L;
const int isc_range_in_use = 335544507L;
const int isc_range_not_found = 335544508L;
const int isc_charset_not_found = 335544509L;
const int isc_lock_timeout = 335544510L;
const int isc_prcnotdef = 335544511L;
const int isc_prcmismat = 335544512L;
const int isc_wal_bugcheck = 335544513L;
const int isc_wal_cant_expand = 335544514L;
const int isc_codnotdef = 335544515L;
const int isc_xcpnotdef = 335544516L;
const int isc_except = 335544517L;
const int isc_cache_restart = 335544518L;
const int isc_bad_lock_handle = 335544519L;
const int isc_jrn_present = 335544520L;
const int isc_wal_err_rollover2 = 335544521L;
const int isc_wal_err_logwrite = 335544522L;
const int isc_wal_err_jrn_comm = 335544523L;
const int isc_wal_err_expansion = 335544524L;
const int isc_wal_err_setup = 335544525L;
const int isc_wal_err_ww_sync = 335544526L;
const int isc_wal_err_ww_start = 335544527L;
const int isc_shutdown = 335544528L;
const int isc_existing_priv_mod = 335544529L;
const int isc_primary_key_ref = 335544530L;
const int isc_primary_key_notnull = 335544531L;
const int isc_ref_cnstrnt_notfound = 335544532L;
const int isc_foreign_key_notfound = 335544533L;
const int isc_ref_cnstrnt_update = 335544534L;
const int isc_check_cnstrnt_update = 335544535L;
const int isc_check_cnstrnt_del = 335544536L;
const int isc_integ_index_seg_del = 335544537L;
const int isc_integ_index_seg_mod = 335544538L;
const int isc_integ_index_del = 335544539L;
const int isc_integ_index_mod = 335544540L;
const int isc_check_trig_del = 335544541L;
const int isc_check_trig_update = 335544542L;
const int isc_cnstrnt_fld_del = 335544543L;
const int isc_cnstrnt_fld_rename = 335544544L;
const int isc_rel_cnstrnt_update = 335544545L;
const int isc_constaint_on_view = 335544546L;
const int isc_invld_cnstrnt_type = 335544547L;
const int isc_primary_key_exists = 335544548L;
const int isc_systrig_update = 335544549L;
const int isc_not_rel_owner = 335544550L;
const int isc_grant_obj_notfound = 335544551L;
const int isc_grant_fld_notfound = 335544552L;
const int isc_grant_nopriv = 335544553L;
const int isc_nonsql_security_rel = 335544554L;
const int isc_nonsql_security_fld = 335544555L;
const int isc_wal_cache_err = 335544556L;
const int isc_shutfail = 335544557L;
const int isc_check_constraint = 335544558L;
const int isc_bad_svc_handle = 335544559L;
const int isc_shutwarn = 335544560L;
const int isc_wrospbver = 335544561L;
const int isc_bad_spb_form = 335544562L;
const int isc_svcnotdef = 335544563L;
const int isc_no_jrn = 335544564L;
const int isc_transliteration_failed = 335544565L;
const int isc_start_cm_for_wal = 335544566L;
const int isc_wal_ovflow_log_required = 335544567L;
const int isc_text_subtype = 335544568L;
const int isc_dsql_error = 335544569L;
const int isc_dsql_command_err = 335544570L;
const int isc_dsql_constant_err = 335544571L;
const int isc_dsql_cursor_err = 335544572L;
const int isc_dsql_datatype_err = 335544573L;
const int isc_dsql_decl_err = 335544574L;
const int isc_dsql_cursor_update_err = 335544575L;
const int isc_dsql_cursor_open_err = 335544576L;
const int isc_dsql_cursor_close_err = 335544577L;
const int isc_dsql_field_err = 335544578L;
const int isc_dsql_internal_err = 335544579L;
const int isc_dsql_relation_err = 335544580L;
const int isc_dsql_procedure_err = 335544581L;
const int isc_dsql_request_err = 335544582L;
const int isc_dsql_sqlda_err = 335544583L;
const int isc_dsql_var_count_err = 335544584L;
const int isc_dsql_stmt_handle = 335544585L;
const int isc_dsql_function_err = 335544586L;
const int isc_dsql_blob_err = 335544587L;
const int isc_collation_not_found = 335544588L;
const int isc_collation_not_for_charset = 335544589L;
const int isc_dsql_dup_option = 335544590L;
const int isc_dsql_tran_err = 335544591L;
const int isc_dsql_invalid_array = 335544592L;
const int isc_dsql_max_arr_dim_exceeded = 335544593L;
const int isc_dsql_arr_range_error = 335544594L;
const int isc_dsql_trigger_err = 335544595L;
const int isc_dsql_subselect_err = 335544596L;
const int isc_dsql_crdb_prepare_err = 335544597L;
const int isc_specify_field_err = 335544598L;
const int isc_num_field_err = 335544599L;
const int isc_col_name_err = 335544600L;
const int isc_where_err = 335544601L;
const int isc_table_view_err = 335544602L;
const int isc_distinct_err = 335544603L;
const int isc_key_field_count_err = 335544604L;
const int isc_subquery_err = 335544605L;
const int isc_expression_eval_err = 335544606L;
const int isc_node_err = 335544607L;
const int isc_command_end_err = 335544608L;
const int isc_index_name = 335544609L;
const int isc_exception_name = 335544610L;
const int isc_field_name = 335544611L;
const int isc_token_err = 335544612L;
const int isc_union_err = 335544613L;
const int isc_dsql_construct_err = 335544614L;
const int isc_field_aggregate_err = 335544615L;
const int isc_field_ref_err = 335544616L;
const int isc_order_by_err = 335544617L;
const int isc_return_mode_err = 335544618L;
const int isc_extern_func_err = 335544619L;
const int isc_alias_conflict_err = 335544620L;
const int isc_procedure_conflict_error = 335544621L;
const int isc_relation_conflict_err = 335544622L;
const int isc_dsql_domain_err = 335544623L;
const int isc_idx_seg_err = 335544624L;
const int isc_node_name_err = 335544625L;
const int isc_table_name = 335544626L;
const int isc_proc_name = 335544627L;
const int isc_idx_create_err = 335544628L;
const int isc_wal_shadow_err = 335544629L;
const int isc_dependency = 335544630L;
const int isc_idx_key_err = 335544631L;
const int isc_dsql_file_length_err = 335544632L;
const int isc_dsql_shadow_number_err = 335544633L;
const int isc_dsql_token_unk_err = 335544634L;
const int isc_dsql_no_relation_alias = 335544635L;
const int isc_indexname = 335544636L;
const int isc_no_stream_plan = 335544637L;
const int isc_stream_twice = 335544638L;
const int isc_stream_not_found = 335544639L;
const int isc_collation_requires_text = 335544640L;
const int isc_dsql_domain_not_found = 335544641L;
const int isc_index_unused = 335544642L;
const int isc_dsql_self_join = 335544643L;
const int isc_stream_bof = 335544644L;
const int isc_stream_crack = 335544645L;
const int isc_db_or_file_exists = 335544646L;
const int isc_invalid_operator = 335544647L;
const int isc_conn_lost = 335544648L;
const int isc_bad_checksum = 335544649L;
const int isc_page_type_err = 335544650L;
const int isc_ext_readonly_err = 335544651L;
const int isc_sing_select_err = 335544652L;
const int isc_psw_attach = 335544653L;
const int isc_psw_start_trans = 335544654L;
const int isc_invalid_direction = 335544655L;
const int isc_dsql_var_conflict = 335544656L;
const int isc_dsql_no_blob_array = 335544657L;
const int isc_dsql_base_table = 335544658L;
const int isc_duplicate_base_table = 335544659L;
const int isc_view_alias = 335544660L;
const int isc_index_root_page_full = 335544661L;
const int isc_dsql_blob_type_unknown = 335544662L;
const int isc_req_max_clones_exceeded = 335544663L;
const int isc_dsql_duplicate_spec = 335544664L;
const int isc_unique_key_violation = 335544665L;
const int isc_srvr_version_too_old = 335544666L;
const int isc_drdb_completed_with_errs = 335544667L;
const int isc_dsql_procedure_use_err = 335544668L;
const int isc_dsql_count_mismatch = 335544669L;
const int isc_blob_idx_err = 335544670L;
const int isc_array_idx_err = 335544671L;
const int isc_key_field_err = 335544672L;
const int isc_no_delete = 335544673L;
const int isc_del_last_field = 335544674L;
const int isc_sort_err = 335544675L;
const int isc_sort_mem_err = 335544676L;
const int isc_version_err = 335544677L;
const int isc_inval_key_posn = 335544678L;
const int isc_no_segments_err = 335544679L;
const int isc_crrp_data_err = 335544680L;
const int isc_rec_size_err = 335544681L;
const int isc_dsql_field_ref = 335544682L;
const int isc_req_depth_exceeded = 335544683L;
const int isc_no_field_access = 335544684L;
const int isc_no_dbkey = 335544685L;
const int isc_jrn_format_err = 335544686L;
const int isc_jrn_file_full = 335544687L;
const int isc_dsql_open_cursor_request = 335544688L;
const int isc_ib_error = 335544689L;
const int isc_cache_redef = 335544690L;
const int isc_cache_too_small = 335544691L;
const int isc_log_redef = 335544692L;
const int isc_log_too_small = 335544693L;
const int isc_partition_too_small = 335544694L;
const int isc_partition_not_supp = 335544695L;
const int isc_log_length_spec = 335544696L;
const int isc_precision_err = 335544697L;
const int isc_scale_nogt = 335544698L;
const int isc_expec_short = 335544699L;
const int isc_expec_long = 335544700L;
const int isc_expec_ushort = 335544701L;
const int isc_like_escape_invalid = 335544702L;
const int isc_svcnoexe = 335544703L;
const int isc_net_lookup_err = 335544704L;
const int isc_service_unknown = 335544705L;
const int isc_host_unknown = 335544706L;
const int isc_grant_nopriv_on_base = 335544707L;
const int isc_dyn_fld_ambiguous = 335544708L;
const int isc_dsql_agg_ref_err = 335544709L;
const int isc_complex_view = 335544710L;
const int isc_unprepared_stmt = 335544711L;
const int isc_expec_positive = 335544712L;
const int isc_dsql_sqlda_value_err = 335544713L;
const int isc_invalid_array_id = 335544714L;
const int isc_extfile_uns_op = 335544715L;
const int isc_svc_in_use = 335544716L;
const int isc_err_stack_limit = 335544717L;
const int isc_invalid_key = 335544718L;
const int isc_net_init_error = 335544719L;
const int isc_loadlib_failure = 335544720L;
const int isc_network_error = 335544721L;
const int isc_net_connect_err = 335544722L;
const int isc_net_connect_listen_err = 335544723L;
const int isc_net_event_connect_err = 335544724L;
const int isc_net_event_listen_err = 335544725L;
const int isc_net_read_err = 335544726L;
const int isc_net_write_err = 335544727L;
const int isc_integ_index_deactivate = 335544728L;
const int isc_integ_deactivate_primary = 335544729L;
const int isc_cse_not_supported = 335544730L;
const int isc_tra_must_sweep = 335544731L;
const int isc_unsupported_network_drive = 335544732L;
const int isc_io_create_err = 335544733L;
const int isc_io_open_err = 335544734L;
const int isc_io_close_err = 335544735L;
const int isc_io_read_err = 335544736L;
const int isc_io_write_err = 335544737L;
const int isc_io_delete_err = 335544738L;
const int isc_io_access_err = 335544739L;
const int isc_udf_exception = 335544740L;
const int isc_lost_db_connection = 335544741L;
const int isc_no_write_user_priv = 335544742L;
const int isc_token_too_long = 335544743L;
const int isc_max_att_exceeded = 335544744L;
const int isc_login_same_as_role_name = 335544745L;
const int isc_reftable_requires_pk = 335544746L;
const int isc_usrname_too_long = 335544747L;
const int isc_password_too_long = 335544748L;
const int isc_usrname_required = 335544749L;
const int isc_password_required = 335544750L;
const int isc_bad_protocol = 335544751L;
const int isc_dup_usrname_found = 335544752L;
const int isc_usrname_not_found = 335544753L;
const int isc_error_adding_sec_record = 335544754L;
const int isc_error_modifying_sec_record = 335544755L;
const int isc_error_deleting_sec_record = 335544756L;
const int isc_error_updating_sec_db = 335544757L;
const int isc_sort_rec_size_err = 335544758L;
const int isc_bad_default_value = 335544759L;
const int isc_invalid_clause = 335544760L;
const int isc_too_many_handles = 335544761L;
const int isc_optimizer_blk_exc = 335544762L;
const int isc_invalid_string_constant = 335544763L;
const int isc_transitional_date = 335544764L;
const int isc_read_only_database = 335544765L;
const int isc_must_be_dialect_2_and_up = 335544766L;
const int isc_blob_filter_exception = 335544767L;
const int isc_exception_access_violation = 335544768L;
const int isc_exception_datatype_missalignment = 335544769L;
const int isc_exception_array_bounds_exceeded = 335544770L;
const int isc_exception_float_denormal_operand = 335544771L;
const int isc_exception_float_divide_by_zero = 335544772L;
const int isc_exception_float_inexact_result = 335544773L;
const int isc_exception_float_invalid_operand = 335544774L;
const int isc_exception_float_overflow = 335544775L;
const int isc_exception_float_stack_check = 335544776L;
const int isc_exception_float_underflow = 335544777L;
const int isc_exception_integer_divide_by_zero = 335544778L;
const int isc_exception_integer_overflow = 335544779L;
const int isc_exception_unknown = 335544780L;
const int isc_exception_stack_overflow = 335544781L;
const int isc_exception_sigsegv = 335544782L;
const int isc_exception_sigill = 335544783L;
const int isc_exception_sigbus = 335544784L;
const int isc_exception_sigfpe = 335544785L;
const int isc_ext_file_delete = 335544786L;
const int isc_ext_file_modify = 335544787L;
const int isc_adm_task_denied = 335544788L;
const int isc_extract_input_mismatch = 335544789L;
const int isc_insufficient_svc_privileges = 335544790L;
const int isc_file_in_use = 335544791L;
const int isc_service_att_err = 335544792L;
const int isc_ddl_not_allowed_by_db_sql_dial = 335544793L;
const int isc_cancelled = 335544794L;
const int isc_unexp_spb_form = 335544795L;
const int isc_sql_dialect_datatype_unsupport = 335544796L;
const int isc_svcnouser = 335544797L;
const int isc_depend_on_uncommitted_rel = 335544798L;
const int isc_svc_name_missing = 335544799L;
const int isc_too_many_contexts = 335544800L;
const int isc_datype_notsup = 335544801L;
const int isc_dialect_reset_warning = 335544802L;
const int isc_dialect_not_changed = 335544803L;
const int isc_database_create_failed = 335544804L;
const int isc_inv_dialect_specified = 335544805L;
const int isc_valid_db_dialects = 335544806L;
const int isc_sqlwarn = 335544807L;
const int isc_dtype_renamed = 335544808L;
const int isc_extern_func_dir_error = 335544809L;
const int isc_date_range_exceeded = 335544810L;
const int isc_inv_client_dialect_specified = 335544811L;
const int isc_valid_client_dialects = 335544812L;
const int isc_optimizer_between_err = 335544813L;
const int isc_service_not_supported = 335544814L;
const int isc_generator_name = 335544815L;
const int isc_udf_name = 335544816L;
const int isc_bad_limit_param = 335544817L;
const int isc_bad_skip_param = 335544818L;
const int isc_io_32bit_exceeded_err = 335544819L;
const int isc_invalid_savepoint = 335544820L;
const int isc_dsql_column_pos_err = 335544821L;
const int isc_dsql_agg_where_err = 335544822L;
const int isc_dsql_agg_group_err = 335544823L;
const int isc_dsql_agg_column_err = 335544824L;
const int isc_dsql_agg_having_err = 335544825L;
const int isc_dsql_agg_nested_err = 335544826L;
const int isc_exec_sql_invalid_arg = 335544827L;
const int isc_exec_sql_invalid_req = 335544828L;
const int isc_exec_sql_invalid_var = 335544829L;
const int isc_exec_sql_max_call_exceeded = 335544830L;
const int isc_conf_access_denied = 335544831L;
const int isc_wrong_backup_state = 335544832L;
const int isc_wal_backup_err = 335544833L;
const int isc_cursor_not_open = 335544834L;
const int isc_bad_shutdown_mode = 335544835L;
const int isc_concat_overflow = 335544836L;
const int isc_bad_substring_param = 335544837L;
const int isc_foreign_key_target_doesnt_exist = 335544838L;
const int isc_foreign_key_references_present = 335544839L;
const int isc_no_update = 335544840L;
const int isc_cursor_already_open = 335544841L;
const int isc_stack_trace = 335544842L;
const int isc_ctx_var_not_found = 335544843L;
const int isc_ctx_namespace_invalid = 335544844L;
const int isc_ctx_too_big = 335544845L;
const int isc_ctx_bad_argument = 335544846L;
const int isc_identifier_too_long = 335544847L;
const int isc_gfix_db_name = 335740929L;
const int isc_gfix_invalid_sw = 335740930L;
const int isc_gfix_incmp_sw = 335740932L;
const int isc_gfix_replay_req = 335740933L;
const int isc_gfix_pgbuf_req = 335740934L;
const int isc_gfix_val_req = 335740935L;
const int isc_gfix_pval_req = 335740936L;
const int isc_gfix_trn_req = 335740937L;
const int isc_gfix_full_req = 335740940L;
const int isc_gfix_usrname_req = 335740941L;
const int isc_gfix_pass_req = 335740942L;
const int isc_gfix_subs_name = 335740943L;
const int isc_gfix_wal_req = 335740944L;
const int isc_gfix_sec_req = 335740945L;
const int isc_gfix_nval_req = 335740946L;
const int isc_gfix_type_shut = 335740947L;
const int isc_gfix_retry = 335740948L;
const int isc_gfix_retry_db = 335740951L;
const int isc_gfix_exceed_max = 335740991L;
const int isc_gfix_corrupt_pool = 335740992L;
const int isc_gfix_mem_exhausted = 335740993L;
const int isc_gfix_bad_pool = 335740994L;
const int isc_gfix_trn_not_valid = 335740995L;
const int isc_gfix_unexp_eoi = 335741012L;
const int isc_gfix_recon_fail = 335741018L;
const int isc_gfix_trn_unknown = 335741036L;
const int isc_gfix_mode_req = 335741038L;
const int isc_gfix_opt_SQL_dialect = 335741039L;
const int isc_dsql_dbkey_from_non_table = 336003074L;
const int isc_dsql_transitional_numeric = 336003075L;
const int isc_dsql_dialect_warning_expr = 336003076L;
const int isc_sql_db_dialect_dtype_unsupport = 336003077L;
const int isc_isc_sql_dialect_conflict_num = 336003079L;
const int isc_dsql_warning_number_ambiguous = 336003080L;
const int isc_dsql_warning_number_ambiguous1 = 336003081L;
const int isc_dsql_warn_precision_ambiguous = 336003082L;
const int isc_dsql_warn_precision_ambiguous1 = 336003083L;
const int isc_dsql_warn_precision_ambiguous2 = 336003084L;
const int isc_dsql_ambiguous_field_name = 336003085L;
const int isc_dsql_udf_return_pos_err = 336003086L;
const int isc_dsql_invalid_label = 336003087L;
const int isc_dsql_datatypes_not_comparable = 336003088L;
const int isc_dsql_cursor_invalid = 336003089L;
const int isc_dsql_cursor_redefined = 336003090L;
const int isc_dsql_cursor_not_found = 336003091L;
const int isc_dsql_cursor_exists = 336003092L;
const int isc_dsql_cursor_rel_ambiguous = 336003093L;
const int isc_dsql_cursor_rel_not_found = 336003094L;
const int isc_dsql_cursor_not_open = 336003095L;
const int isc_dyn_role_does_not_exist = 336068796L;
const int isc_dyn_no_grant_admin_opt = 336068797L;
const int isc_dyn_user_not_role_member = 336068798L;
const int isc_dyn_delete_role_failed = 336068799L;
const int isc_dyn_grant_role_to_user = 336068800L;
const int isc_dyn_inv_sql_role_name = 336068801L;
const int isc_dyn_dup_sql_role = 336068802L;
const int isc_dyn_kywd_spec_for_role = 336068803L;
const int isc_dyn_roles_not_supported = 336068804L;
const int isc_dyn_domain_name_exists = 336068812L;
const int isc_dyn_field_name_exists = 336068813L;
const int isc_dyn_dependency_exists = 336068814L;
const int isc_dyn_dtype_invalid = 336068815L;
const int isc_dyn_char_fld_too_small = 336068816L;
const int isc_dyn_invalid_dtype_conversion = 336068817L;
const int isc_dyn_dtype_conv_invalid = 336068818L;
const int isc_dyn_zero_len_id = 336068820L;
const int isc_gbak_unknown_switch = 336330753L;
const int isc_gbak_page_size_missing = 336330754L;
const int isc_gbak_page_size_toobig = 336330755L;
const int isc_gbak_redir_ouput_missing = 336330756L;
const int isc_gbak_switches_conflict = 336330757L;
const int isc_gbak_unknown_device = 336330758L;
const int isc_gbak_no_protection = 336330759L;
const int isc_gbak_page_size_not_allowed = 336330760L;
const int isc_gbak_multi_source_dest = 336330761L;
const int isc_gbak_filename_missing = 336330762L;
const int isc_gbak_dup_inout_names = 336330763L;
const int isc_gbak_inv_page_size = 336330764L;
const int isc_gbak_db_specified = 336330765L;
const int isc_gbak_db_exists = 336330766L;
const int isc_gbak_unk_device = 336330767L;
const int isc_gbak_blob_info_failed = 336330772L;
const int isc_gbak_unk_blob_item = 336330773L;
const int isc_gbak_get_seg_failed = 336330774L;
const int isc_gbak_close_blob_failed = 336330775L;
const int isc_gbak_open_blob_failed = 336330776L;
const int isc_gbak_put_blr_gen_id_failed = 336330777L;
const int isc_gbak_unk_type = 336330778L;
const int isc_gbak_comp_req_failed = 336330779L;
const int isc_gbak_start_req_failed = 336330780L;
const int isc_gbak_rec_failed = 336330781L;
const int isc_gbak_rel_req_failed = 336330782L;
const int isc_gbak_db_info_failed = 336330783L;
const int isc_gbak_no_db_desc = 336330784L;
const int isc_gbak_db_create_failed = 336330785L;
const int isc_gbak_decomp_len_error = 336330786L;
const int isc_gbak_tbl_missing = 336330787L;
const int isc_gbak_blob_col_missing = 336330788L;
const int isc_gbak_create_blob_failed = 336330789L;
const int isc_gbak_put_seg_failed = 336330790L;
const int isc_gbak_rec_len_exp = 336330791L;
const int isc_gbak_inv_rec_len = 336330792L;
const int isc_gbak_exp_data_type = 336330793L;
const int isc_gbak_gen_id_failed = 336330794L;
const int isc_gbak_unk_rec_type = 336330795L;
const int isc_gbak_inv_bkup_ver = 336330796L;
const int isc_gbak_missing_bkup_desc = 336330797L;
const int isc_gbak_string_trunc = 336330798L;
const int isc_gbak_cant_rest_record = 336330799L;
const int isc_gbak_send_failed = 336330800L;
const int isc_gbak_no_tbl_name = 336330801L;
const int isc_gbak_unexp_eof = 336330802L;
const int isc_gbak_db_format_too_old = 336330803L;
const int isc_gbak_inv_array_dim = 336330804L;
const int isc_gbak_xdr_len_expected = 336330807L;
const int isc_gbak_open_bkup_error = 336330817L;
const int isc_gbak_open_error = 336330818L;
const int isc_gbak_missing_block_fac = 336330934L;
const int isc_gbak_inv_block_fac = 336330935L;
const int isc_gbak_block_fac_specified = 336330936L;
const int isc_gbak_missing_username = 336330940L;
const int isc_gbak_missing_password = 336330941L;
const int isc_gbak_missing_skipped_bytes = 336330952L;
const int isc_gbak_inv_skipped_bytes = 336330953L;
const int isc_gbak_err_restore_charset = 336330965L;
const int isc_gbak_err_restore_collation = 336330967L;
const int isc_gbak_read_error = 336330972L;
const int isc_gbak_write_error = 336330973L;
const int isc_gbak_db_in_use = 336330985L;
const int isc_gbak_sysmemex = 336330990L;
const int isc_gbak_restore_role_failed = 336331002L;
const int isc_gbak_role_op_missing = 336331005L;
const int isc_gbak_page_buffers_missing = 336331010L;
const int isc_gbak_page_buffers_wrong_param = 336331011L;
const int isc_gbak_page_buffers_restore = 336331012L;
const int isc_gbak_inv_size = 336331014L;
const int isc_gbak_file_outof_sequence = 336331015L;
const int isc_gbak_join_file_missing = 336331016L;
const int isc_gbak_stdin_not_supptd = 336331017L;
const int isc_gbak_stdout_not_supptd = 336331018L;
const int isc_gbak_bkup_corrupt = 336331019L;
const int isc_gbak_unk_db_file_spec = 336331020L;
const int isc_gbak_hdr_write_failed = 336331021L;
const int isc_gbak_disk_space_ex = 336331022L;
const int isc_gbak_size_lt_min = 336331023L;
const int isc_gbak_svc_name_missing = 336331025L;
const int isc_gbak_not_ownr = 336331026L;
const int isc_gbak_mode_req = 336331031L;
const int isc_gbak_just_data = 336331033L;
const int isc_gbak_data_only = 336331034L;
const int isc_gsec_cant_open_db = 336723983L;
const int isc_gsec_switches_error = 336723984L;
const int isc_gsec_no_op_spec = 336723985L;
const int isc_gsec_no_usr_name = 336723986L;
const int isc_gsec_err_add = 336723987L;
const int isc_gsec_err_modify = 336723988L;
const int isc_gsec_err_find_mod = 336723989L;
const int isc_gsec_err_rec_not_found = 336723990L;
const int isc_gsec_err_delete = 336723991L;
const int isc_gsec_err_find_del = 336723992L;
const int isc_gsec_err_find_disp = 336723996L;
const int isc_gsec_inv_param = 336723997L;
const int isc_gsec_op_specified = 336723998L;
const int isc_gsec_pw_specified = 336723999L;
const int isc_gsec_uid_specified = 336724000L;
const int isc_gsec_gid_specified = 336724001L;
const int isc_gsec_proj_specified = 336724002L;
const int isc_gsec_org_specified = 336724003L;
const int isc_gsec_fname_specified = 336724004L;
const int isc_gsec_mname_specified = 336724005L;
const int isc_gsec_lname_specified = 336724006L;
const int isc_gsec_inv_switch = 336724008L;
const int isc_gsec_amb_switch = 336724009L;
const int isc_gsec_no_op_specified = 336724010L;
const int isc_gsec_params_not_allowed = 336724011L;
const int isc_gsec_incompat_switch = 336724012L;
const int isc_gsec_inv_username = 336724044L;
const int isc_gsec_inv_pw_length = 336724045L;
const int isc_gsec_db_specified = 336724046L;
const int isc_gsec_db_admin_specified = 336724047L;
const int isc_gsec_db_admin_pw_specified = 336724048L;
const int isc_gsec_sql_role_specified = 336724049L;
const int isc_license_no_file = 336789504L;
const int isc_license_op_specified = 336789523L;
const int isc_license_op_missing = 336789524L;
const int isc_license_inv_switch = 336789525L;
const int isc_license_inv_switch_combo = 336789526L;
const int isc_license_inv_op_combo = 336789527L;
const int isc_license_amb_switch = 336789528L;
const int isc_license_inv_parameter = 336789529L;
const int isc_license_param_specified = 336789530L;
const int isc_license_param_req = 336789531L;
const int isc_license_syntx_error = 336789532L;
const int isc_license_dup_id = 336789534L;
const int isc_license_inv_id_key = 336789535L;
const int isc_license_err_remove = 336789536L;
const int isc_license_err_update = 336789537L;
const int isc_license_err_convert = 336789538L;
const int isc_license_err_unk = 336789539L;
const int isc_license_svc_err_add = 336789540L;
const int isc_license_svc_err_remove = 336789541L;
const int isc_license_eval_exists = 336789563L;
const int isc_gstat_unknown_switch = 336920577L;
const int isc_gstat_retry = 336920578L;
const int isc_gstat_wrong_ods = 336920579L;
const int isc_gstat_unexpected_eof = 336920580L;
const int isc_gstat_open_err = 336920605L;
const int isc_gstat_read_err = 336920606L;
const int isc_gstat_sysmemex = 336920607L;
const int isc_err_max = 736;

}



static char create_tbl[]  = "CREATE TABLE dbinfo (when_created DATE)";
static char insert_date[] = "INSERT INTO dbinfo VALUES ('NOW')";

int main ()
{
    isc_db_handle   newdb = null;          /* database handle */
    isc_tr_handle   trans = null;          /* transaction handle */
    ISC_STATUS_ARRAY status;               /* status vector */
    long            sqlcode;               /* SQLCODE  */
//    char            create_db[160] = "CREATE DATABASE 'new.fdb'";        /* 'create database' statement */
//    char            new_dbname[128] = "new.fdb";
    char[] create_db = "CREATE DATABASE 'new1.fdb'";        /* 'create database' statement */
    char[] new_dbname = "new1.fdb";

    setUserAndPassword();
    
    /*
     *    Construct a 'create database' statement.
     *    The database name could have been passed as a parameter.
     */
    //sprintf(create_db, "CREATE DATABASE '%s'", new_dbname);
    
    /*
     *    Create a new database.
     *    The database handle is zero.
     */
    
    if (isc_dsql_execute_immediate(status, &newdb, &trans, 0, create_db, 1, null))
    {
        /* Extract SQLCODE from the status vector. */
        sqlcode = isc_sqlcode(status);

        /* Print a descriptive message based on the SQLCODE. */
        if (sqlcode == -902)
        {
            printf("\nDatabase already exists.\n");
            printf("Remove %s before running this program.\n\n", toStringz(new_dbname));
        }

        /* In addition, print a standard error message. */
        if (pr_error(status, "create database"))
            return 1;
    }

    isc_commit_transaction(status, &trans);
    printf("Created database '%s'.\n\n", toStringz(new_dbname));

    /*
     *    Connect to the new database and create a sample table.
     */

    /* newdb will be set to null on success */ 
    isc_detach_database(status, &newdb);

    if (isc_attach_database(status, 0, new_dbname, &newdb, 0, null))
        if (pr_error(status, "attach database"))
            return 1;


    /* Create a sample table. */
    isc_start_transaction(status, &trans, 1, &newdb, 0, null);
    if (isc_dsql_execute_immediate(status, &newdb, &trans, 0, create_tbl, 1, null))
        if (pr_error(status, "create table"))
            return 1;
    isc_commit_transaction(status, &trans);

    /* Insert 1 row into the new table. */
    isc_start_transaction(status, &trans, 1, &newdb, 0, null);
    if (isc_dsql_execute_immediate(status, &newdb, &trans, 0, insert_date, 1, null))
        if (pr_error(status, "insert into"))
            return 1;
    isc_commit_transaction(status, &trans);

    printf("Successfully accessed the newly created database.\n\n");

    isc_detach_database(status, &newdb);

    return 0;
}            

/*
 *    Print the status, the SQLCODE, and exit.
 *    Also, indicate which operation the error occured on.
 */
int pr_error (ISC_STATUS_ARRAY status, char *operation)
{
    printf("[\n");
    printf("PROBLEM ON \"%s\".\n", operation);

    isc_print_status(status);

    printf("SQLCODE:%d\n", isc_sqlcode(status));

    printf("]\n");

    return 1;
}
